#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxn = 1000003;
ll fact[maxn];

ll binpow(ll x, ll st, ll mod)
{
	ll ans = 1;
	while (st)
	{
		if (st & 1)
			ans = (ans * x) % mod;
		x = (x * x) % mod;
		st >>= 1;
	}
	return ans;
}

ll getC(ll n, ll k, ll mod)
{
	ll ans = 1;
	for (ll i = 0; i < k; i++)
		ans = (ans * (n - i)) % mod;
	return (ans * binpow(fact[k], mod - 2, mod)) % mod;
}

int main()
{
	//freopen("a.in", "r", stdin);
	ll mod = 1000000007;
	fact[0] = 1;
	for (int i = 1; i <= 1000000; i++)
		fact[i] = (fact[i-1] * i) % mod;
	int T;
	cin >> T;
	for (int g = 1; g <= T; g++)
	{
		ll n, m, k;
		cin >> n >> m >> k;
		ll ans = getC(m, k, mod);
		ans = (ans * k) % mod;
		ans = (ans * binpow(k - 1, n - 1, mod));
		cout << "Case #" << g << ": " << ans << "\n";
	}
	return 0;
}