#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long

using namespace std;
ll t, n, m, k;

ll fact(ll l, ll r)
{
    if (l == 0 && r == 0)
        return 1ll;
    if (l == 0) l++;
    ll res = 1;
    for (int i = l; i < r + 1; i++)
        res = ((res % md) * (i % md)) % md;
    return res;
}

ll power(ll x, ll s)
{
    if (s == 0)
        return 1;
    if (s == 1)
        return x;
    return ((power(x, s / 2) % md) * (power(x, (s + 1) / 2) % md));
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    cin >> t;
    for (int i = 0; i < t; i++)
    {
        cin >> n >> m >> k;
        ll ans = (fact(m - k + 1, m) * power(k - 1, n - k)) % md;
        cout << "Case #" << i + 1 << ": " << ans << endl;
    }
    return 0;
}
