#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long

using namespace std;
ll t, n, m, k;

ll fact(ll l, ll r)
{
    if (l == 0 && r == 0)
        return 1ll;
    if (l == 0) l++;
    ll res = 1;
    for (ll i = l; i < r + 1; i++)
        res = (res * (i % md)) % md;
    return res;
}

ll binpow (ll a, ll n) {
	ll res = 1;
	while (n)
		if (n & 1) {
			res *= a;
			res %= md;
			--n;
		}
		else {
			a *= a;
			a %= md;
			n >>= 1;
		}
	return res;
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    cin >> t;
    for (int i = 0; i < t; i++)
    {
        cin >> n >> m >> k;
        ll ans = (1ll * fact(m - k + 1, m) * binpow(k - 1, n - k)) % md;
        cout << "Case #" << i + 1 << ": " << ans << endl;
    }
    return 0;
}
