#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 100000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long

using namespace std;
long long t, n;
long long s1, s2;

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    cin >> t;
    for (int i = 0; i < t; i++) {
        long long s1 ,s2;
        cin >> s1 >> s2;
        if (min(s1, s2) == 0 && max(s1, s2) != 0) {
            cout << "Case #" << i + 1 << ": " << 2 << endl;
            continue;
        }
        long long result = 1;
        while (s1 > 0 && s2 > 0) {
            if (s1 > s2) {
                result += s1 / s2;
                s1 %= s2;
            } else {
                result += s2 /s1;
                s2 %= s1;
            }
        }
        cout << "Case #" << i + 1 << ": " << result << endl;
    }

    return 0;
}
