#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

double ANS;

vector<int> onestep(const vector<int>& a) {
	int invs = 0;
	int n = sz(a);
	forn(i, n) forn(j, i) if (a[i] < a[j]) invs++;
	double curans = (double)invs/sz(a);
	ANS = curans;
	if (sz(a) == 1) return a;
	double bestans = -1;
	int bp = -1;
	forn(i, n) {
		int cc = 0;
		forn(j, n) {
			if (j < i && a[j] > a[i]) ++cc;
			if (j > i && a[i] > a[j]) ++cc;
		}
		double tans = (double)(invs - cc)/(n-1);
		if (tans > bestans) {
			bestans = tans;
			bp = i;
		}
	}
	if (bestans <= curans) return a;
	vector<int> res = a;
	res.erase(res.begin()+bp);
	return res;
}

void solve() {
	int n; scanf("%d", &n);
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]);
	while (true) {
		vector<int> res = onestep(a);
		if (sz(res) == sz(a)) break;
		a = res;
	}
	printf("%.15lf\n", ANS);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); for (int t = 1; t <= T; ++t) {
		printf("Case #%d: ", t);
		solve();
	}
	return 0;
}
