#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

ll ABS(ll a){
	if(a<0)
		return a*(-1);
	else
		return a;
}

int calc(ll a,ll b){
	set<ll> dist;
	dist.insert(a);
	dist.insert(b);
	while(a && b){
		ll next = ABS(a-b);
		a = b;
		b = next;
		dist.insert(next);
//		cout << next << " ";
	}
	return L(dist);
}

//ll solve(ll a, ll b) {
//
//}

void SOLVE() {
	ll a, b; scanf("%lld%lld", &a, &b);
	ll ans = 0;
	while (b) {
		ll q = a/b;
		ans += q;
		a -= q * b;
		swap(a, b);
	}
	cout << ans + 1<< "\n";
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); for (int t = 1; t <= T; ++t) {
		printf("Case #%d: ", t);
		SOLVE();
	}
	return 0;
}
