#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e6+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, k, m;
int fact[maxn], inv[maxn];

int binpow(int a, int k) {
	if(k == 0) return 1;
	int ans = binpow(a, k / 2);
	ans = 1ll * ans * ans % mod;
	if(k&1) ans = 1ll * ans * a % mod;
	return ans;
}

int c(int n, int k) {
	int p = fact[n];
	int q = 1ll * inv[k] * 1ll * inv[n-k] % mod;
	return 1ll * p * q % mod;
}

void solve() {
	cin >> n >> m >> k;

	if(k == 1) {
		if(n > 1) cout << 0 << endl;
		else cout << m << endl;
	} else {
		int ans = c(m, k);
		ans = 1ll * ans * k % mod;
		ans = 1ll * ans * binpow(k-1, n-1) % mod;
		cout << ans << endl;
	}
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	fact[0] = inv[0] = 1;
	for(int i = 1; i < maxn; i++) {
		fact[i] = 1ll * i * fact[i-1] % mod;
		inv[i] = binpow(fact[i], mod-2);
	}

	int t;

	cin >> t;

	for(int i = 1; i <= t; i++) {
		printf("Case %d: ", i);
		solve();
	}
	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
