#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e6+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, k, m;
int fact[maxn], inv[maxn];

int binpow(int a, int k) {
	if(k == 0) return 1;
	int ans = binpow(a, k / 2);
	ans = 1ll * ans * ans % mod;
	if(k&1) ans = 1ll * ans * a % mod;
	return ans;
}

int c(int n, int k) {
	int p = 1;
	for(int i = 1; i <= k; i++) p = 1ll * p * (n-k+i) % mod;
	p = 1ll * p * inv[k] % mod;
	return p;
}

int g(int n, int k) {
	int ans = k;
	return 1ll * ans * binpow(k-1, n-1) % mod;
}

int f(int n, int k) {
	return (g(n, k) - n * 1ll * g(n, k-1) % mod + mod) % mod;
}

void solve() {
	cin >> n >> m >> k;

	int sgn = 1;
	int ans = 0;
	int last = -1;
	for(int i = k; i >= 1; i--) {
		int temp;
		if(i == k) temp = c(m, i);
		else {
			temp = last;
			temp = 1ll * temp * i % mod;
			temp = 1ll * temp * binpow(m-i+1, mod-2) % mod;
		}
		last = temp;
		temp = 1ll * temp * i % mod;
		temp = 1ll * temp * binpow(i-1, n-1) % mod;
		temp = temp * sgn;
		if(temp < 0) temp += mod;
		ans = (ans + temp) % mod;
	}
	cout << ans << endl;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	fact[0] = inv[0] = 1;
	for(int i = 1; i < maxn; i++) {
		fact[i] = 1ll * i * fact[i-1] % mod;
		inv[i] = binpow(fact[i], mod-2);
	}

	int t;

	cin >> t;

	for(int i = 1; i <= t; i++) {
		printf("Case #%d: ", i);
		solve();
	}
	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
