#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int dp[111][111][2];
int used[111][111][2];
int n, m;
vector < int > g[111];

int dfs(int x, int y, int t){
	//cout << x <<  " " << y << " " << t << endl;
	if( x == y ) return false;
	if( dp[x][y][t] == 1) return 1;
	if( dp[x][y][t] == 2) return used[x][y][t];
	dp[x][y][t] = 1;
	if( t == 1 ) {
		int &ok = used[x][y][t];
		ok = 1;
		forit(it, g[y]){
			ok &= dfs(x, *it, 0);
		}
	}
	else {
		int &ok = used[x][y][t];
		ok = 0;
		forit(it, g[x]){
			ok |= dfs(*it, y, 1);
		}
	}
	dp[x][y][t] = 2;
	return used[x][y][t];
}

void solve(){
	scanf("%d %d", &n, &m);
	for(int i = 0, x, y; i < m; ++i){
		scanf("%d %d", &x, &y);
		x--;
		y--;
		g[x].pb(y);
	}
	int x, y;
	scanf("%d %d", &x, &y);
	memset(dp, 0, sizeof dp);
	x--;
	y--;
	int ok = dfs(x, y, 0);
	if(ok) cout << "Yes\n";
	else cout << "No\n";
	for(int i = 0; i < n; i++){
		g[i].clear();
	}
}


int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif


	int t;
	scanf("%d", &t);
	for(int i = 1; i <= t; i++){
		printf("Case #%d: ", i);
		solve();
	}




	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
