#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6 + 2;
const int mod = (int)1e9 + 7;
const int inf = (1 << 30) - 1;

int m, n, k, T;
LL Cm, C, res, ans;
LL rev[maxn];

LL binpow(LL x, LL pw) {
	LL res = 1;
	while (pw) {
		if (pw & 1) res = res * x % mod;
		x = x * x % mod;
		pw >>= 1;
	}
	return res;
}

int main()
{

	rev[1] = 1;
	for (int i = 2; i < maxn; i++) 
		rev[i] = (mod - mod / i * 1ll * rev[mod % i] % mod) % mod;
	
	scanf("%d", &T);
	for (int q = 1; q <= T; q++) {
		scanf("%d %d %d", &n, &m, &k);
		Cm = 1;
		for (int i = 1; i <= k; ++i) {
			Cm = Cm * rev[i] % mod;
			Cm = Cm * (m - i + 1) % mod;
		}

		C = 1;
		res = 0;
		for (int i = 0; i < k; i++) {
			LL term = (i & 1 ? mod-1 : 1);
			term = term * C % mod;
			term = term * (k - i) % mod;
			term = term * binpow(k - i - 1, n - 1) % mod;

			res = (res + term) % mod;
			
			C = C * (k - i) % mod * rev[i + 1] % mod;
		}
		
		ans = Cm * res % mod;
		printf("Case #%d: %d\n", q, ans);
	}

	return 0;
}







