#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;

string ans[maxn], res, s[maxn];
int n, cnt, T, len[maxn], b, d[maxn][2], all, c, v, f[maxn], l;
char st[maxn];
LL x, a;
map <LL, int> was;
              
int add(string &s, int x)
{
	res = "";
	for (int i = 0; i < 8; i++)
	{
		if (x & (1 << i))
			res += "1";
		else
			res += "0";
	}
	reverse(res.begin(), res.end());
	s += res;
}

string NumToStr(int x)
{
	if (x < 10)
	{
		string s;
		s = char(x + '0');
		return s;
	}
	else
		return NumToStr(x / 10) + NumToStr(x % 10);
}

void go(string s)
{
	v = 0;
	for (int i = 0; i < s.length(); i++)
	{
		s[i] -= '0';
		if (!d[v][s[i]])
			d[v][s[i]] = ++all;
	  	v = d[v][s[i]]; 	
	}
	f[v] = 1;
}

LL calc(string s)
{
	int l = s.length();
	LL cur = 0;
	for (int i = 0; i < l; i++)
	{
		if (s[i] == '1')
			cur += (1ll << (31 - i));
	}
	return cur;
}

void dfs(int v)
{
	if (f[v])
		return;
  	if (d[v][0] && d[v][1])
  	{
  		st[++c] = '0';
  		dfs(d[v][0]);
  		st[c] = '1';
  		dfs(d[v][1]);
  		c--;
  	}
  	else
  	if (d[v][0])
  	{
  		cnt++;
  		ans[cnt] = "";
  		for (int i = 1; i <= c; i++)
  			ans[cnt] += st[i];
  	  	ans[cnt] += "1";
  	  	len[cnt] = c;
  	  	st[++c] = '0';
  	  	dfs(d[v][0]);
  		c--;
  	}
  	else
  	if (d[v][1])
  	{
  		cnt++;
  		ans[cnt] = "";
  		for (int i = 1; i <= c; i++)
  			ans[cnt] += st[i];
  	  	ans[cnt] += "0";
  	    len[cnt] = c;
  	    st[++c] = '1';
  		dfs(d[v][1]);
  		c--;
  	}
}

void show(LL x, int p)
{
	if (!p)
		return ;
	show(x >> 8, p - 1);
	cout << x % (1ll << 8);
	if (p != 4)
		cout << ".";
	
}

int main()
{
	//freopen(fname"in", "r", stdin);
	//freopen(fname"out", "w", stdout);

	cin >> T;

	for (int test = 1; test <= T; test++)
	{
		cout << "Case #" << test << ":\n";
		cin >> n;
		
		if (n == 0)
		{
			cout << 1 << "\n";
			cout << "0.0.0.0/0\n";
			continue;
		}
		
		for (int i = 0; i <= all; i++)
		{
			f[i] = 0;
			d[i][0] = d[i][1] = 0;
		}
		all = 0;
		int D = 0;
		for (int i = 1; i <= n; i++)
		{
			scanf("%d.%d.%d.%d/%d", &a, &b, &c, &D, &l);
			s[i] = "";
			add(s[i], a);
			add(s[i], b);
			add(s[i], c);
			add(s[i], D);
			s[i] = s[i].substr(0, l);
			go(s[i]);
		}

		c = cnt = 0;
		dfs(0);

		cout << cnt << "\n";
		for (int t = 1; t <= cnt; t++)
		{
			a = calc(ans[t]);
			show(a, 4);
		  	cout << "/" << len[t] + 1 << "\n";
		}
	}
	return 0;
}
