#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

bool was[111][111];

vector<int> g[111],gr[111];

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int T; cin >> T;

	for (int t = 1; t <= T; t++) {
		printf("Case #%d: ",t);
		int n,m; cin >> n >> m;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				was[i][j] = false;
			}
		}
		for (int i = 0; i < n; i++) {
			g[i].clear();
			gr[i].clear();
		}
		for (int i = 0; i < m; i++) {
			int a,b; scanf("%d%d",&a,&b); --a; --b;
			g[a].pb(b);
			gr[b].pb(a);
		}
		queue<pii> q;
		for (int i = 0; i < n; i++) {
			was[i][i] = true;
			q.push(mp(i,i));
		}
		for (int i = 0; i < n; i++) if (sz(g[i]) == 0) {
			for (int j = 0; j < n; j++) if (i != j) {
				was[i][j] = true;
				q.push(mp(i,j));
			}
		} else if (sz(g[i]) == 1) {
			was[i][g[i][0]] = true;
			q.push(mp(i,g[i][0]));
		}
		while(!q.empty()) {
			int x = q.front().first;
			int y = q.front().second;
			q.pop();
			for (int i = 0; i < sz(gr[x]); i++) {
				int xx = gr[x][i];
				for (int j = 0; j < sz(gr[y]); j++) {
					int yy = gr[y][j];
					if (sz(g[xx]) == 1 || (sz(g[xx]) == 2 && ((g[xx][0] == x && g[xx][1] == yy) || (g[xx][0] == yy && g[xx][1] == x)))) {
						if (!was[xx][yy]) {
							was[xx][yy] = true;
							q.push(mp(xx,yy));
						}
					}
				}
			}
		}
		int x,y; cin >> x >> y; --x; --y;
		puts(was[x][y] ? "No" : "Yes");
	}

	return 0;
}
