#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <sstream>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 1000000

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

struct node
{
	int val;
	int next[2];
	node():val(0) { memset(next,-1,sizeof(next)); }
	void init()
	{
		val = 0;
		memset(next,-1,sizeof(next));
	}
};

node a[MAXN];
int n, m;
string s, t;
char c[MAXN];

inline void init()
{
	a[0].init();
	n = 1;
}

inline void add()
{
	int v = 0;
	for (int i = 0; i < sz(s); ++i)
	{
		a[v].val = max(1, a[v].val);
		int cur = s[i] - '0';
		if (a[v].next[cur] == -1)
		{
			a[n].init();
			a[v].next[cur] = n++;
		}
		v = a[v].next[cur];
	}
	a[v].val = 2;
}

vector <string> ans;

inline void go(int v, int l)
{
	if (a[v].val == 2) return;
	if (a[v].val == 0)
	{
		ans.pb(s.substr(0, l));
		return;
	}
	for (int i = 0; i < 2; ++i)
	{
		s[l] = '0' + i;
		if (a[v].next[i] != -1)
			go(a[v].next[i], l + 1);
		else
			ans.pb(s.substr(0, l + 1));
	}
}

inline string i2s(int x)
{
	ostringstream os;
	os << x;
	return os.str();
}

inline void get(string& s)
{
	int blen = sz(s);
	while(sz(s) < 32)
		s += '0';
	t = "";
	for (int i = 0; i < sz(s); i += 8)
	{
		int sub = 0;
		for (int j = 7; j >= 0; --j)
			sub = sub + (s[i + j] - '0') * (1 << (7 - j));
		t += i2s(sub);
		if (i + 8 < sz(s))
			t += '.';
	}
	s = t + "/" + i2s(blen);
}

inline void solve()
{	
	scanf("%d", &m);
	ans.clear();
	init();
	for (int z = 0; z < m; ++z)
	{
		scanf("%s", c);
		t = c;

		int len = sz(t);
		int pos = -1;
		for (int i = 0; i < len; ++i)
			if (t[i] == '/')
			{
				pos = i;
				break;
			}

		int blen = 0;
		for (int i = pos + 1; pos != -1 && i < len; ++i)
			blen = blen * 10 + t[i] - '0';
		t = t.substr(0, pos) + ".";
		len = sz(t);
		
		s = "";
		for (int i = 0, sub = 0; i < len; ++i)
		{
			if (t[i] == '.')
			{
				for (int j = 0; j < 8; ++j, sub >>= 1)
					s += char('0' + (sub & 1));
				reverse(s.begin() + sz(s) - 8, s.end());
			}
			else
				sub = sub * 10 + t[i] - '0';
		}
		s = s.substr(0, blen);
		add();
	}
	s = "";
	for (int i = 0; i < 32; ++i)
		s += "0";
	go(0, 0);
	printf("%d\n", sz(ans));
	for (int i = 0; i < sz(ans); ++i)
	{
		get(ans[i]);
		printf("%s\n", ans[i].c_str());
	}
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int tt;
	scanf("%d", &tt);
	for (int t = 0; t < tt; ++t)
	{
		printf("Case #%d:\n", t + 1);
		solve();
	}

	return 0;
}
