#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "f"
#define long long long

#define M 1001000
const long mod = 1000000000 + 7;
long f[M], r[M];

long bin(long x, long a)
{
	long y = 1;
	while (a)
	{
		if (a & 1)
			y = (y * x) % mod;
		x = (x * x) % mod;
		a >>= 1;
	}
	return y;
}

void pre_fact()
{
	r[0] = 1;
	r[1] = 1;
	for (int i = 2; i < M; ++i)
	{
		r[i] = -1 * (mod / i) * r[mod % i];
		r[i] %= mod;
		if (r[i] < 0)
			r[i] += mod;
	}
	
	
	f[0] = f[1] = 1;
	for (int i = 1; i < M; ++i)
	{
		r[i] = (r[i] * r[i - 1]) % mod;
		f[i] = (f[i - 1] * i) % mod;
	}
}

void kill()
{
	long n, m, k;
	cin >> n >> m >> k;
	
	long ans = 0;
	for (long j = 0; j < k; ++j)
	{
		long foo = (r[k - j] * f[k]) % mod;
		foo = (foo * r[j]) % mod;
		foo = (foo * (k - j)) % mod;
		foo = (foo * bin(k - j - 1, n - 1)) % mod;
		if (j & 1)
			ans = (ans - foo) % mod;
		else
			ans = (ans + foo) % mod;
	}
	
	
	
	long cnk = 1;
	for (int i = 0; i < k; ++i)
		cnk = (cnk * (m - i)) % mod;
	cnk = (cnk * r[k]) % mod;
	ans = (ans * cnk) % mod;
	
	ans %= mod;
	
	if (ans < 0)
		ans += mod;
	
	cout << ans << "\n";
}


int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	pre_fact();
	int tn;
	cin >> tn;
	for (int i = 1; i <= tn; ++i)
	{
		cout << "Case #" << i << ": ";
		kill();
	}
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
