#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "h"

const int maxn = 150;

int n, m, x, y;
vector<int> g[maxn], invg[maxn * maxn * 2];
int deg[maxn * maxn * 2], res[maxn * maxn * 2], q[maxn * maxn * 2];

void putEdge(int u, int v)
{
	deg[u]++;
	invg[v].pb(u);
}

void solve(int t)
{
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		g[i].clear(), deg[i] = 0;
	for (int i = 0; i < 2 * n * n; ++i)
		invg[i].clear();

	for (int i = 0; i < m; ++i)
	{
		int a, b;
		scanf("%d%d", &a, &b), --a, --b;
		g[a].pb(b);
	}
	scanf("%d%d", &x, &y);
	--x, --y;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
		{
			if (i == j) continue;
			for (int v : g[i])
			{
				int p1 = i * n * 2 + j * 2 + 0;
				int p2 = v * n * 2 + j * 2 + 1;
				putEdge(p1, p2);
			}
			for (int v : g[j])
			{
				int p1 = i * n * 2 + j * 2 + 1;
				int p2 = i * n * 2 + v * 2 + 0;
				putEdge(p1, p2);
			}
		}
	int qh = 0, qt = 0;
	fill(res, res + n * n * 2, 0);
	for (int i = 0; i < n * n * 2; ++i)
		if (deg[i] == 0)
		{
			int a = i / (2 * n), b = (i / 2) % n;
			if (a == b)
			{
				if (i & 1) res[i] = 1;
				else res[i] = -1;
			}
			else res[i] = -1;
			q[qt++] = i;
		}
	while (qh < qt)
	{
		int v = q[qh++];
		//cerr << v << endl;
		assert(res[v] != 0);
		assert(res[v] != 100500);
		for (int to : invg[v])
		{
			if (deg[to] == 0) continue;
			if (res[v] == -1)
			{
				res[to] = 1;
				deg[to] = 0;
				q[qt++] = to;
			}
			else if (--deg[to] == 0)
			{
				res[to] = -1;
				q[qt++] = to;
			}
		}
	}
	int start = x * n * 2 + y * 2 + 0;
	printf("Case #%d: %s\n", t, res[start] >= 0 ? "Yes" : "No");
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	scanf("%d", &t);
	for (int i = 1; i <= t; ++i)
		solve(i);
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
