#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <vector>

using namespace std;

#define uint long long

class vert{
public:
    int next[2];
    vert() {next[0] = next[1] = -1;};
};

vector<vert> g;

bool bit(uint mask, uint x) {
    return (1<<x)&mask;
}

void addMask(uint mask, uint len) {
    int cur = 0;
    for (int i = 0; i < len; ++i) {
        cerr << cur << " " << len << endl;
        bool b = bit(mask, 31 - i);
        if (g[cur].next[b] == -1) {
            g.push_back(vert());
            g[cur].next[b] = g.size() - 1;
        }
        cur = g[cur].next[b];
    }
}

vector<string> ans;

vector<int> getP(uint mask) {
//    cerr << "mask == " << mask << " " << mask % 256 << endl;
    vector<int> p;
    p.push_back(mask % 256);
    mask /= 256;
//    cerr << "mask == " << mask << " " << mask % 256 << endl;
    p.push_back(mask % 256);
    mask /= 256;
//    cerr << "mask == " << mask << " " << mask % 256 << endl;
    p.push_back(mask % 256);
    mask /= 256;
//    cerr << "mask == " << mask << " " << mask % 256 << endl;
    p.push_back(mask % 256);
    reverse(p.begin(), p.end());
    return p;
}

void dfs(int v, uint len, uint mask) {
/*    cerr << g.size() << endl;
    cerr << v << " " << len << " " << mask << endl;
    cerr << g[v].next[0] << " " << g[v].next[1] << endl;*/

    if (g[v].next[0] + g[v].next[1] == -2)
        return;

    for (int b = 0; b < 2; ++b) {
        if (g[v].next[b] == -1) {
            vector<int> p = getP(b == 1 ? (mask | (1ll<<(32 - len - 1))) : mask);
//            cerr << b << " " << (b == 1 ? (mask | (1ll<<(32 - len - 1))) : mask) << " " << p[0] << " " << p[1] << " " << p[2] << " " << p[3] << endl;
            char tmp[20];
//            cerr << "write ans" << endl;
            sprintf(tmp, "%d.%d.%d.%d/%d", p[0], p[1], p[2], p[3], int(len + 1));
//            cerr << "write ans" << endl;
            ans.push_back(string(tmp));
        } else {
//            cerr << "from: " << v << " by " << b << " " << "Go: " << g[v].next[b] << endl;
            dfs(g[v].next[b], len + 1, b == 1 ? (mask | (1ll<<(32 - len - 1))) : mask);
        }
    }
//    cerr << "Exit: " << v << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        int n;
        g.clear();
        ans.clear();
        g.push_back(vert());
        cin >> n;
        for (int i = 0; i < n; ++i) {
            int p1, p2, p3, p4, s;
            scanf("%d.%d.%d.%d/%d", &p1, &p2, &p3, &p4, &s);
            uint pl1 = p1;
            uint pl2 = p2;
            uint pl3 = p3;
            uint pl4 = p4;

//            cerr << bit(pl1, 7) << " " << pl1 << endl;

            uint mask = (pl1 << 24) + (pl2 << 16) + (pl3 << 8) + pl4;
//            cerr << bit(mask, 31) << endl;
//            cerr << "add mask == " << mask << endl;
            addMask(mask, s);
        }
        if (n != 0)
            dfs(0, 0, 0);
        else {
            ans.push_back("0.0.0.0/0");
        }

        cout << "Case #" << test << ":\n";
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); ++i)
            cout << ans[i] << "\n";
    }
    return 0;
}
