#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <cstdio>
#include <set>
#include <map>

using namespace std;

const long long MOD = 1000000007;

long long pow2(long long n, long long k)
{
	long long t = 1;
	while(k){
		if(k & 1){
			t *= n;
			t %= MOD;
		}
		n*= n;
		n %= MOD;
		k >>= 1;
	}
	return t;
}

void update(int newv, int i, vector<int>& f){
	for(; i < f.size(); i = (i + 1) | i){
		f[i] += newv;
	}
}

int sum(int r, vector<int>& f){
	int ans = 0;
	for(; r >= 0; r = ((r+1) & r) - 1){
		ans += f[r];
	}
	return ans;
}

struct Bits{
	unsigned int bits;
	set<unsigned int> ip;
};


inline void printsolve(unsigned int a, unsigned int b){
	cout << (a >>24) << '.' << (a << 8 >> 24) << '.' << (a  << 16 >> 24) << '.' << (a << 24 >> 24) << '/' << b << endl;
}

inline unsigned int reverseb(unsigned int a, int i){
	return a ^ (1 << i);
}

inline unsigned int nulling(unsigned int a, int i){
	return a & reverseb((0 - 1), i);
}

struct otv{
	int a, b;
};

void solve(int j)
{
	unsigned int n;
	cin >> n;
	vector<otv>ot;
	map<int, vector<unsigned int> > s;
	for(int i = 0; i< n; i++){
		unsigned int a, b, c, d, e;
		scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &e);
		a = a*256*256*256 + b*256*256 + c*256 + d;
		s[e].push_back(a);
	}
	cout << "Case #" << j << ": " << endl;
	
	for(unsigned int i = 32; i > 0; i--){
		for(unsigned int j = 0; j < s[i].size(); j++){
			otv o;
			o.a = reverseb(s[i][j], 32 - i);
			o.b = i;
			ot.push_back(o);
			s[i-1].push_back(nulling(s[i][j], 32 - i));
		}
	}

	if(ot.size() == 0){
		otv o;
		o.a = 0;
		o.b = 0;
		ot.push_back(o);
	}
	cout << ot.size() << endl;
	for(int i = 0; i < ot.size(); i++)
		printsolve(ot[i].a, ot[i].b);

}

int main()
{
	int t;
	//cout << nulling(1536, 10);
	cin >> t;
	for(int i = 0; i < t; i++)
		solve(i+1);
	//cout << pow2(3, 3);
	//cin >> t;
	return 0;
}