#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int n, m;
vector<vector<int> > g;
vector<vector<int> > ans[2];
vector<vector<int> > used[2];

int Calc(int x, int y, int z)
{
    used[z][x][y] = 1;
    ans[z][x][y] = 0;

    if (x == y) {
        if (z == 1) {
            ans[z][x][y] = 1;
            return 1;
        } else {
            return 0;
        }
    }

    int nz = (z + 1) & 1;

    if (z == 0) {
        for (int i = 0; i < (int) g[x].size(); ++i) {
            int nx = g[x][i];
            if (used[nz][nx][y]) {
                ans[z][x][y] = 1;
            } else {
                if (!Calc(nx, y, nz)) {
                    ans[z][x][y] = 1;
                }
            }
        }
    } else {
        for (int i = 0; i < (int) g[y].size(); ++i) {
            int ny = g[y][i];
            if (!used[nz][x][ny]) {
                if (!Calc(x, ny, nz)) {
                    ans[z][x][y] = 1;
                }
            }
        }

    }

    return ans[z][x][y];
}

int main()
{
   // freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        cin >> n >> m;
        g.clear();
        g.resize(n);
        for (int i = 0; i < m; ++i) {
            int v1, v2;
            cin >> v1 >> v2;
            --v1; --v2;
            g[v1].push_back(v2);
        }

        int x, y;
        cin >> x >> y;
        --x; --y;

        for (int i = 0; i < 2; ++i) {
            ans[i].assign(n, vector<int>(n));
            used[i].assign(n, vector<int>(n, 0));
        }

        cout << "Case #" << test << ": ";
        if (Calc(x, y, 0)) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }

    return 0;
}
