#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();

void precalc();

int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;
	precalc();
	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}

#define int li

int mod = 1000000007;

int binpow(int q, int w) {
	if (!w)
		return 1;
	if (w & 1)
		return q * binpow(q, w - 1) % mod;
	return binpow(q * q % mod, w / 2);
}

const int C = 1000002;

int rev[C];

int minPrime[C];

void precalc() {
	for (int i = 1; i < C; ++i)
		rev[i] = binpow(i, mod - 2);
	for (int i = 2; i < C; ++i)
		if (minPrime[i] == 0) {
			if (i * 1LL * i > C)
				continue;
			for (int j = i * i; j < C; j += i)
				minPrime[j] = i;
		}
}

int timer = 0;

int step[C];

void solve() {
	++timer;
	cout << "Case #" << timer << ": ";
	int n, m, k;
	cin >> n >> m >> k;
	
	int ans = 0;

	int C = 1;

	step[0] = ((n == 1) ? 1 : 0);
	step[1] = 1;
	for (int i = 2; i <= k; ++i) {
		if (minPrime[i] == 0)
			step[i] = binpow(i, n - 1);
		else
			step[i] = step[minPrime[i]] * step[i / minPrime[i]] % mod;
	}

	for (signed i = 0; i < k; ++i) {
		if (i & 1)
			ans = ans - C * step[k - i - 1];
		else
			ans = ans + C * step[k - i - 1];
		if (abs(ans) > 1e18)
			ans %= mod;

		C = C * (k - i - 1) % mod * rev[i + 1] % mod;
	}

	ans %= mod;

	ans = ans * k % mod;

	for (signed i = 1; i <= k; ++i) {
		int add = (m - i + 1) * rev[i] % mod;
		ans = ans * add % mod;
	}

	cout << (ans + mod) % mod << "\n";

}