#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	//cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	int timer = 0;
	while(t--) {
		++timer;
		cout << "Case #" << timer << ": \n";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


#define int li


vector<string> ans;


pair<li, li> readRange() {

	signed a,b,c,d, e;
	scanf("%d.%d.%d.%d/%d", &a, &b, &c,&d, &e);

	li start = (li(a) << 24) + (li(b) << 16) + (li(c) << 8) + li(d);
	li mask = (1LL << 32) - (1LL << (32-e));

	//cout << start << ' ' << mask << ' ' << (1LL << (32 - e)) <<endl;

	return mp(start & mask, (start & mask) + (1LL << (32 - e)));
}

string iptostr(li start, li mask) {

	string res;
	res += to_string(start >> 24);
	res += ".";
	res += to_string((start >> 16) & 255);
	res += ".";
	res += to_string((start >> 8) & 255);
	res += ".";
	res += to_string((start) & 255);
	res += "/";
	res += to_string(mask);
	return res;
}
void add_ans(li a, li b) {

	//cout << a << ' ' << b << endl;

	for(int i = 0; i <= 32;++i) {

		li m = 1LL << i;
		if(a == b) 
			break;

		//cout << a << ' ' << b << ' ' << ' ' << m << (a & m )<< endl;
		if(a & m) {

			ans.push_back(iptostr(a, 32 - i));
			a += m;
		}
		if(b & m) {
			b -= m;
			ans.push_back(iptostr(b, 32 - i));
		}
	}
}
void solve() {
	signed n;
	scanf("%d", &n);
	ans.clear();


	vector<pair<li, li> > events;
	for(int i = 0; i < n; ++i){

		pair<li, li> x = readRange();
		events.push_back(mp(x.first, -1));
		events.push_back(mp(x.second, 1));

		//cout << "here " << x.first << ' ' <<x.second << endl;

	}

	sort(all(events));

	li prevstart = 0;
	int opened = 0;

	for(int i = 0; i < events.size(); ++i){
		if(opened == 0) {
			add_ans(prevstart, events[i].first);
		}
		prevstart = events[i].first;
		opened -= events[i].second;
	}


	add_ans(prevstart, 1LL << 32);


	

	cout << ans.size() << "\n";
	for(int i = 0; i < ans.size(); ++i) {
		cout << ans[i] << "\n";
	}
}