#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

struct qwe
{
	long long x;
	int t;
} a[66666];

bool cmp(const qwe &a, const qwe &b)
{
	return (a.x < b.x || ((a.x == b.x) && (a.t > b.t)));
}

long long l[66666], r[66666];
int k;
vector<pair<long long, int> > ans;

void solve(long long l, long long r, long long l0, long long r0, int h)
{
	//cout << l << " " << r << " " << l0 << " " << r0 << " " << h << endl;
	if (l0 <= l && r <= r0)
	{
		ans.push_back(make_pair(l, h));
		return;
	}
	if (l0 > r || r0 < l)
		return;
	solve(l, (l + r) / 2, l0, r0, h+1);
	solve((l + r) / 2 + 1, r, l0, r0, h+1);
	
}

int main()
{
	 int tests;

    scanf("%d", &tests);

    for (int test = 1; test <= tests; test++) {
			int n;
        scanf("%d", &n);
		string s;
		
		for(int i = 0; i < n; i++)
		{
			long long a1, a2, a3, a4, pr;
			
			scanf("%lld.%lld.%lld.%lld/%lld", &a1, &a2, &a3, &a4, &pr);
			long long ip = ((a1 << 24) | (a2 << 16) | (a3 << 8) | a4);
			ip = ((ip >> (32 - pr)) << (32 - pr));
			a[i * 2].x = ip;
			a[i * 2].t = 1;
			a[i * 2 + 1].x = (long long)ip + (1LL << (32 - pr)) - 1;
			a[i * 2 + 1].t = -1;
		}
		n = n * 2;
		sort(a, a + n, cmp);
		int k = 0;
		long long last = -1;
		int cnt = 0;
		for(int i = 0; i < n; i++)
		{
			if (!cnt && last + 1 <= a[i].x - 1) {
				l[k] = last + 1;
				r[k] = a[i].x - 1;
				k++;
			}
			cnt += a[i].t;
			last = a[i].x;
		}
		if (last + 1 <= (1LL << 32) - 1) {
			l[k] = last + 1;
			r[k] = (1LL << 32) - 1;
			k++;
		}
		ans.clear();
		for(int i = 0; i < k; i++)
		{
			solve(0, (1LL << 32) - 1, l[i], r[i], 0);
		}
		
		printf("Case #%d:\n", test);
		printf("%d\n", ans.size());
		for(int i = 0; i < ans.size(); i++)
		{
			printf("%lld.%lld.%lld.%lld/%d\n", ans[i].first >> 24, (ans[i].first >> 16) & ((1 << 8) - 1), (ans[i].first >> 8) & ((1 << 8) - 1), ans[i].first & ((1 << 8) - 1), ans[i].second);
		}
	}
	return 0;	
}