#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const li MOD = 1000000007LL;

inline li binpow(li a, li n) {
	if (n == 1)
		return 1;
	if (n % 2 == 1)
		return binpow(a, n - 1) * a % MOD;
	else {
		int x = binpow(a, n / 2);
		return x * x % MOD;
	}
}

inline li rev(li a) {
	return binpow(a, MOD - 2);
}

inline li C(int n, int k) {
	li up = 1, down = 1;
	for (li i = 0; i < k; i++) {
		down = down * (i + 1) % MOD;
		up = up * (n - i) % MOD;
	}
	return up * rev(down) % MOD;
}

li dp[1000000];

void solve(int test) {
	int n, m, k;
	cin >> n >> m >> k;
	cout << "Case #" << test << ": ";
	li c = C(m, k);
	if (n == 1) {
		if (k == 1) {
			cout << m << endl;
		} else
			cout << 0 << endl;
		return;
	}
	dp[1] = 0;
	for (li i = 2; i <= k; i++) {
		li s1 = binpow(k - 1, n - 1) * k % MOD;
		li s2 = 0;
		for (li j = 1; j < i; j++) {
			li s3 = dp[j] * C(j, i) % MOD;
			s2 = (s2 + s3) % MOD;
		}
		dp[i] = ((s1 - s2) % MOD + MOD) % MOD;
	}
	cout << dp[k] << endl;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		solve(i + 1);
}