#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

struct node {
    int link;
    int next[26];
    int len;
    int cnt[2];
    node() {
        memset(next, 255, sizeof(next));
        memset(cnt, 0, sizeof(cnt));
    }
};

const int N = 1e6;

node nodes[N];

int sz = 0;

int add(int cur, int pos, const string & s, int k) {
    while (s[pos - nodes[cur].len - 1] != s[pos]) {
        cur = nodes[cur].link;
        assert(cur != -1);
    }
    int u = nodes[cur].link;
    int to = nodes[cur].next[s[pos] - 'a'];
    int link = (u != cur) ? add(u, pos, s, -1) : cur;
    if (to == -1) {
        to = nodes[cur].next[s[pos] - 'a'] = sz++;
        nodes[to].len = nodes[cur].len + 2;
        nodes[to].link = link;
    }
    if (k >= 0) nodes[to].cnt[k]++;
    return to;
}

int root = 0;

void init() {
    for (int i = 0; i < sz; ++i) {
        memset(nodes[i].next, 255, sizeof(nodes[i].next));
        memset(nodes[i].cnt, 0, sizeof(nodes[i].cnt));
    }
    sz = 0;
    nodes[sz++].len = -1;
    nodes[sz++].len = 0;
    nodes[0].link = nodes[1].link = 0;
}

void solve(){
    in(t);
    int c = 0;
    while (t--) {
        cout << "Case #" << ++c << ": ";
        init();
        string a, b;
        cin >> a >> b;
        int cur = root;
        for (int i = 0; i < (int)a.length(); ++i) {
            cur = add(cur, i, a, 0);
        }
        cur = root;
        for (int i = 0; i < (int)b.length(); ++i) {
            cur = add(cur, i, b, 1);
        }
        int N = max(a.length(), b.length()) + 1;
        vector <int> byLen[N + 1];
        for (int i = 0; i < sz; ++i) {
            byLen[nodes[i].len + 1].push_back(i);
        }
        long long ans = 0;
        for (int i = N; i >= 0; --i) {
            for (int nd : byLen[i]) {
                if (nodes[nd].len > 0) {
                    ans += (long long)nodes[nd].cnt[0] * nodes[nd].cnt[1];
                }
                nodes[nodes[nd].link].cnt[0] += nodes[nd].cnt[0];
                nodes[nodes[nd].link].cnt[1] += nodes[nd].cnt[1];
            }
        }
        cout << ans << "\n";
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
