#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>
#include <queue>
#include <stack>
using namespace std;

typedef long long ll;

const ll M = 1000000007;
const int N = 1000002;
ll rv[N];
inline ll binpow(ll num, ll pow){
	if (num == 0) return 0;
	ll ans = 1;
	num %= M;
	while (pow){
		if (pow & 1){
			ans *= num;
			ans %= M;
		}
		pow >>= 1;
		num *= num;
		num %= M;
	}
	return ans;
}

inline ll Cnk(ll n, ll k){
	if (k > n) return 0;
	ll ans = 1;
	for (ll i = 0; i < k; ++i){
		ans *= (n - i) % M;
		ans %= M;
		ans *= rv[i + 1];
		ans %= M;
	}
	return ans;
}

ll p[N];

int main(){
	ios_base::sync_with_stdio(false);
	
	for (int i = 0; i < N; ++i)
		rv[i] = binpow(i, M - 2);
		
	int ttt; cin >> ttt;
	for (int t = 0; t < ttt; ++t){
		ll n, m, k;
		cin >> n >> m >> k;
		if (n == 1){
			ll ans = ((k == 1)? m : 0);
			cout << "Case #" << t + 1 << ": " << ans << endl;
			continue;
		}
		p[0] = 1;
		for (int i = 1; i < k; ++i){
			p[i] = p[i - 1] * (k - i + 1) % M * rv[i] % M;
		}
		ll ans = 0;

		for (int i = 0, s = 1; i < k; ++i, s = M - s){
			ll add = s;
			add *= p[i];
			add %= M;
			add *= (k - i);
			add %= M;
			add *= binpow(k - i - 1, n - 1);
			//cout << k * binpow(k - i - 1, n - 1) << ':' << p[i] << endl;
			add %= M;

			ans += add;
			ans %= M;
		}
		ans = ans * Cnk(m, k) % M;
		cout << "Case #" << t + 1 << ": " << ans << endl;
	}
	return 0;
}