#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <unordered_map>
#include <queue>
#include <stack>
using namespace std;

typedef long long ll;

int dp[100][100][2];
bool used[100][100][2];
vector<int> g[100];

inline int ans(int a, int b, int t, int deep = 0){
	if (a == b) {
		dp[a][b][t] = ((t == 0)? 0 : 1);
		return dp[a][b][t];
	};
	if (used[a][b][t]) {
		if (dp[a][b][t] >= 0)
			return dp[a][b][t];
		else{
			if (deep > 10000) if (t == 0){
				return 1;
			} else {
				return 0;
			}
		}
	}
	used[a][b][t] = true;
	if (t == 0){
		//BOB turn
		for (int i = 0; i < g[b].size(); ++i){
			int u = g[b][i];
			if (ans(a, u, 1, deep + 1) == 0) {
				dp[a][b][t] = 1;
				return 1;
			}
		}
		dp[a][b][t] = 0;
	} else {
		//Alice turn
		for (int i = 0; i < g[a].size(); ++i){
			int u = g[a][i];
			if (ans(u, b, 0, deep + 1) == 0) {
				dp[a][b][t] = 1;
				return 1;
			}
		}
		dp[a][b][t] = 0;
	}
	return dp[a][b][t];
}

int main(){
	ios_base::sync_with_stdio(false);
	int ttt; cin >> ttt;
	for (int t = 0; t < ttt; ++t){
		int n, m; cin >> n >> m;
		memset(dp, -1, sizeof(dp));
		memset(used, 0, sizeof(used));
		for (int i = 0; i < n; ++i)
			g[i].resize(0);
		for (int i = 0; i < m; ++i){
			int a, b; cin >> a >> b;
			--a; --b;
			g[a].push_back(b);
		}
		int x, y; cin >> x >> y;
		--x; -- y;
		int b = ans(y, x, 0);
		cout << "Case #" << t + 1 << ": " << (b? "Yes" : "No") << endl;
	}
	return 0;
}