#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll mod = 1000000007;

const int N = 1000000;

struct Input {
	int n, m, k;
	
	bool read () {
		return cin >> n >> m >> k;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void clear () {}
	virtual void solve () {}
};

struct Solution: Data {
	
	ll pw (ll a, ll n) {
		ll ans = 1;
		while (n) {
			if (n & 1) {
				(ans *= a) %= mod;
			}
			(a *= a) %= mod;
			n >>= 1; 
		}
		return ans;
	}
	
	ll f[N + 1], rf[N + 1];
	
	Solution () {
		f[0] = 1;
		rf[0] = 1;
		forn (i, N) {
			f[i + 1] = f[i] * (i + 1) % mod;
			rf[i + 1] = rf[i] * pw(i + 1, mod - 2) % mod;
		}
	}
	
	void solve () {
		ans = 0;
		forn (i, k) {
			ll sgn = (i & 1) ? -1 : 1;
			(ans += mod + sgn * (f[k] * rf[i] % mod * rf[k - i] % mod * (k - i) % mod * pw(k - i - 1, n - 1) % mod)) %= mod;
		}
		forn (i, k) {
			(ans *= m - i) %= mod;
		}
		(ans *= rf[k]) %= mod;
	}
	
	void clear () {
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("f.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		printf("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}
	return 0;
}
