#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int ALPHA = 26;

const int N = 200100;

struct Input {
	char c[2][N];
	
	bool read () {
		if (!gets(c[0]))
			return 0;
		gets(c[1]);
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void clear () {}
	virtual void solve () {}
};

struct Solution: Data {
	vector <int> g[N];	

	struct item {
		int next[ALPHA];
		int link;
		int len;
		ll cnt;
		item() {
			memset(next, -1, sizeof(next));
			link = 1;
			len = -1;
			cnt = 0;
		}	
	};
	
	item a[2][N];
	int sz[2];
	int lst[2];
	
	void add (int idx, int tekc, int n) {
		int cur = lst[idx];
		while (c[idx][n] != c[idx][n - a[idx][cur].len - 1]) {
			cur = a[idx][cur].link;
		}
		if (a[idx][cur].next[tekc] >= 0) {
			lst[idx] = a[idx][cur].next[tekc];
			a[idx][a[idx][cur].next[tekc]].cnt++;
			return;
		}
		a[idx][cur].next[tekc] = sz[idx];
		a[idx][sz[idx]].len = a[idx][cur].len + 2;
		cur = a[idx][cur].link;
		a[idx][sz[idx]].cnt = 1;
		lst[idx] = sz[idx];
		while (c[idx][n] != c[idx][n - a[idx][cur].len - 1]) {
			cur = a[idx][cur].link;
		}	
		if (a[idx][sz[idx]].len > 1) {
			a[idx][sz[idx]].link = a[idx][cur].next[tekc];
		}
		sz[idx]++;
	}
		
	ll dfs (int idx, int v) {
		forn(i, g[v].size()) {
			if (g[v][i] == 0) {
				continue;
			}
			a[idx][v].cnt += dfs(idx, g[v][i]);
		}
		//debug(mp(v, a[idx][v].cnt));
		return a[idx][v].cnt;
	}
	
	void calc (int v, int u) {	
		//debug(mp(v, u));
		if (v > 1 && u > 1)
			ans += 1ll * a[0][v].cnt * a[1][u].cnt; 
		forn(i, 26) {
			int to1 = a[0][v].next[i], to2 = a[1][u].next[i];
			if (to1 >= 0 && to2 >= 0) {
				calc(to1, to2);
			}
		}
	}
	
	void solve () {
		ans = 0;
		forn(i, 2) {
			lst[i] = 0;
			sz[i] = 2;
			a[i][1].link = 0;
			a[i][0].link = 0;
			a[i][1].len = 0; 
			for (int j = 0; c[i][j]; ++j) {
				add(i, (int)c[i][j] - 'a', j);
			}
		}
		forn(i, 2) {
			forn(j, sz[i]) {
				g[a[i][j].link].pb(j);
			}
			dfs(i, 0);
			forn(j, sz[i]) {
				g[j].clear();
			}
		}
		calc(0, 0);
		calc(1, 1);
		forn(i, 2) {
			forn(j, sz[i]) {
				a[i][j] = item();
			}
		}	
	}
	
	void clear () {
		//*this = Solution(); 
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	int t;
	cin >> t;
	string qwe;
	getline(cin, qwe);
	forn(i, t) {
		sol.read();
		sol.solve();
		printf ("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}
	return 0;
}
