#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

struct Input {
	int n, m, x, y;
	ve<pii> ed;
	bool read () {
		if (!(cin >> n >> m)) {
			return 0;
		}
		forn (i, m) {
			int u, v;
			scanf("%d%d", &u, &v);
			--u, --v;
			ed.pb(mp(u, v));
		}
		scanf("%d%d", &x, &y);
		--x, --y;
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	bool ans;
	void write () {
		puts(ans ? "Yes" : "No");
	}
	
	virtual void clear () {}
	virtual void solve () {}
};

const int N = 100;
const int K = 2 * N * N;

struct Solution: Data {
	vi h[N];
	vi g[K], gT[K];
	
	void addEdge (int x, int y, int nx, int ny) {
		int u = x * n + y, v = nx * n + ny;
		g[u * 2].pb(v * 2 + 1);
		gT[v * 2 + 1].pb(u * 2);
		g[u * 2 + 1].pb(v * 2);
		gT[v * 2].pb(u * 2 + 1);
	}
	
	int f[K];
	int k;
	int cnt[K];
	
	void solve () {
		forn (i, m) {
			int u = ed[i].fs, v = ed[i].sc;
			h[u].pb(v);
		}
		k = 2 * n * n;
		
		forn (i, n) {
			forn (j, n) {
				if (i == j) {
					continue;
				}
				forn (it, sz(h[i])) {
					int w = h[i][it];
					addEdge(i, j, j, w);
				}
			}
		}
		
		fill(f, f + k, 0);
		fill(cnt, cnt + k, 0);
		
		queue<int> t;
		forn (i, k) {
			int e = i / 2;
			if (e % n == e / n) {
				f[i] = (i % 2) ? 1 : -1;
				t.push(i);
			}
			else if (sz(g[i]) == 0) {
				t.push(i);
				f[i] = -1;
			}
		}
		while (!t.empty()) {
			int u = t.front();
			t.pop();
			
			forn (i, sz(gT[u])) {
				int v = gT[u][i];
				if (f[u] > 0) {	
					++cnt[v];
					if (cnt[v] == sz(g[v])) {	
						f[v] = -1;
						t.push(v);
					}
				}
				else {	
					if (f[v] == 0) {
						f[v] = 1;
						t.push(v);
					}
				}
			}
		}
		
		ans = (f[(x * n + y) * 2] >= 0);
	}
	
	void clear () {
		ed.clear();
		forn (i, n) {
			h[i].clear();
		}
		forn (i, k) {
			g[i].clear();
			gT[i].clear();
		}
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("h.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	int t;
	cin >> t;
	forn(i, t) {
		sol.read();
		sol.solve();
		printf("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}
	return 0;
}
