#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef unsigned int ui;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 30100;

struct Input {
	int n;
	ui a[N];
	int l[N];
		
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		forn(i, n) {
			int a1, b1, c1, d1;
			scanf ("%d.%d.%d.%d/%d", &a1, &b1, &c1, &d1, &l[i]);
			a[i] = (ui)(a1 << (ui)24) + (ui)(b1 << (ui)16) + (ui)(c1 << (ui)8) + (ui)d1;
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

vector<int> rest (ui a) {
	vector <int> b;
	forn(i, 4) {
		b.pb(a & 255);
		a >>= 8; 
	}
	reverse(b.begin(), b.end());
	return b;
}

struct Data: Input {
	vector <pair<ui, int> > ans;
	
	void write () {
		cout << ans.size() << endl;
		forn(i, ans.size()) {
			vector <int> help = rest(ans[i].fs);
			printf ("%d.%d.%d.%d/%d\n", help[0], help[1], help[2], help[3], ans[i].sc);
		}
	}
	
	virtual void clear () {}
	virtual void solve () {}
};

struct Solution: Data {

	map<ll, bool> upd;
	map<ll, ll> t;
	ll sz;	
	
	inline void push (ll v, ll l, ll r) {
		if (!upd[v]) {
			return;
		}
		t[v] = 1ll * (1ll * r - l + 1);
		if (v < sz) {
			upd[2 * v] = upd[2 * v + 1] = 1;
		}	
		upd[v] = 0;
 	}
 	
 	void upd1 (ll i, ll x, ll y, int h, ui tek, int cnt) {
 		push(i, x, y);
 		if (h == 0) {
 			upd[i] = 1;
 			push(i, x, y);
 			return;
 		}
 		if (tek & ((ui)1 << cnt)) {
 			upd1(2 * i + 1, ((x + y) >> 1) + 1, y, h - 1, tek, cnt - 1);
 		} else {
 			upd1(2 * i, x, ((x + y) >> 1), h - 1, tek, cnt - 1);
 		}
 		if (i < sz) {
 			t[i] = t[2 * i] + t[2 * i + 1];
 		}
 	}	
 	
 	void calc (ll i, ll x, ll y, int h, ui cur) {
		push(i, x, y);
		if (t[i] == (y - x + 1)) {
			return;
		}	
		if (t[i] == 0) {
			ans.pb(mp(cur, h));
			return;
		}
		calc(2 * i, x, (x + y) >> 1, h + 1, cur);
		calc(2 * i + 1, ((x + y) >> 1) + 1, y, h + 1, cur + (1u << (31 - h)));
   	}
  
	void solve () {
		sz = (1ll << 32);
		forn(i, n) {
			upd1(1, 1, sz, l[i], a[i], 31); 
	 	}
	 	calc(1, 1, sz, 0, 0);	
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	int t;
	cin >> t;
	forn(i, t) {
		sol.read();
		sol.solve();
		printf("Case #%d:\n", i + 1);
		sol.write();
		sol.clear();
	}
	return 0;
}
