#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

struct Input {
	ll a, b;
	
	bool read () {
		return cin >> a >> b;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void clear () {}
	virtual void solve () {}
};

struct Solution: Data {
	ve<ll> q;
	
	void solve () {
		ans = 0;
		q.pb(a);
		q.pb(b);
		q.pb(0);
		while (1) {
			q.pb(a);
			q.pb(b);
			if (!a || !b) {
				break;
			}
			if (a >= 4 * b) {
				ll k = (a - 2 * b) / (2 * b);
				q.pb(a - b);
				a -= 2 * b * k;
				ans += 2 * k - 2;
			} else {
				swap(a, b);
				b = abs(a - b);
			}
		}
		sort(all(q));
		q.erase(unique(all(q)), q.end());
		ans += sz(q);
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("k.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	int t;
	cin >> t;
	forn(i, t) {
		sol.read();
		sol.solve();
		printf("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}
	return 0;
}
