import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.MathContext;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * Created by olymp on 11/18/14.
 */
public class task_j {
    public static void main(String[] args) {
        new task_j().run();
    }

    final int N = 55;
    ArrayList<Integer> adj[] = null;
    int size[] = new int[N], n, a[] = new int[N], tc;
    long sum[] = new long[N], cnk[][] = new long[N][N], tmp[][] = new long[N][N], ans[][][] = new long[N][N][N], old[] = new long[N];

    void dfs(int v) {
        size[v] = 1;
        for (int u: adj[v]) {
            dfs(u);
            size[v] += size[u];
        }
        for (int d = 0; d <= n; ++d) {
            for (int j = 0; j <= size[v]; ++j)
                tmp[d][j] = 0;
            tmp[d][0] = 1;
            int total = 0;
            for (int u : adj[v]) {
                for (int j = 0; j <= total; ++j) {
                    old[j] = tmp[d][j];
                    tmp[d][j] = 0;
                }
                for (int j = 0; j <= total; ++j)
                    for (int k = 0; k <= size[u]; ++k)
                        tmp[d][j + k] += old[j] * ans[u][d][k];
                total += size[u];
            }
        }
        for (int d = 0; d <= n; ++d)
            for (int j = 0; j <= size[v]; ++j) {
                ans[v][d][j] = 0;
                if (d > 0) ans[v][d][j] += tmp[d - 1][j];
                if (j > 0) ans[v][d][j] += tmp[Math.max(d - 1, a[v])][j - 1];
            }
    }

    int main() {
        Scanner in = new Scanner(System.in);
        //long start = System.currentTimeMillis();
        tc = in.nextInt();
        for (int i = 0; i < N; ++i) {
            cnk[i][0] = cnk[i][i] = 1;
            for (int j = 1; j < i; ++j)
                cnk[i][j] = cnk[i - 1][j - 1] + cnk[i - 1][j];
        }
        adj = new ArrayList[N];
        for (int it = 0; it < tc; ++it) {
            MathContext mc = new MathContext(40);
            n = in.nextInt();
            for (int i = 0; i < n; ++i) {
                adj[i] = new ArrayList<Integer>();
                a[i] = in.nextInt();
            }
            for (int i = 1; i < n; ++i)
                adj[in.nextInt() - 1].add(i);
            dfs(0);
            BigDecimal total = BigDecimal.ZERO;
            for (int a = 0; a < n; ++a) {
                BigInteger tmp = BigInteger.ZERO;
                for (int i = a, sign = 1; i < n; ++i, sign *= -1)
                    tmp = tmp.add(BigInteger.valueOf((cnk[n][i] - ans[0][0][i]) * sign).multiply(BigInteger.valueOf(cnk[i][a])));
                tmp = tmp.multiply(BigInteger.valueOf(n));
                total = total.add(new BigDecimal(tmp).divide(new BigDecimal(n - a), mc), mc);
            }
            System.out.println("Case #" + (it + 1) + ": " + total);
        }
        //System.err.println(System.currentTimeMillis() - start);
        return 0;
    }

    public void run() {
        main();
    }
}
