#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = 55;
const int LIMIT = (int) 3e3;
vector<int> adj[N];
int size[N], n, a[N], tc, p;
ldb cnk[N][N], sum[N], pw[N][N];
int64 tmp[N][N], ans[N][N][N], old[N];

void dfs(int v) {
	size[v] = 1;
	for (int i = 0; i < sz(adj[v]); ++i) {
		int u = adj[v][i];
		dfs(u);
		size[v] += size[u];
	}
	for (int d = 0; d <= n; ++d) {
		for (int j = 0; j <= size[v]; ++j)
			tmp[d][j] = 0;
		tmp[d][0] = 1;
		int total = 0;
		for (int i = 0; i < sz(adj[v]); ++i) {
			int u = adj[v][i];
			for (int j = 0; j <= total; ++j) {
				old[j] = tmp[d][j];
				tmp[d][j] = 0;
			}
			for (int j = 0; j <= total; ++j)
				for (int k = 0; k <= size[u]; ++k)
					tmp[d][j + k] += old[j] * ans[u][d][k];
			total += size[u];
		}
	}
	for (int d = 0; d <= n; ++d)
		for (int j = 0; j <= size[v]; ++j) {
			ans[v][d][j] = 0;
			if (d > 0) ans[v][d][j] += tmp[d - 1][j];
			if (j > 0) ans[v][d][j] += tmp[max(d - 1, a[v])][j - 1];
		}
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &tc);
	cout.precision(20);
	for (int i = 0; i < N; ++i) {
		cnk[i][0] = cnk[i][i] = 1;
		for (int j = 1; j < i; ++j)
			cnk[i][j] = cnk[i - 1][j - 1] + cnk[i - 1][j];
	}
	for (int i = 0; i < N; ++i) {
		pw[i][0] = 1;
		for (int j = 1; j < N; ++j)
			pw[i][j] = pw[i][j - 1] * i;
	}
	for (int it = 0; it < tc; ++it) {
		scanf("%d", &n);
		for (int i = 0; i < n; ++i) {
			adj[i].clear();
			scanf("%d", &a[i]);
			a[i] = min(a[i], n);
		}
		for (int i = 1; i < n; ++i)
			scanf("%d", &p), adj[p - 1].pb(i);
		dfs(0);
		ldb res = 1;
		for (int x = 1; x < n; ++x)
			for (int i = 1; i <= x; ++i) {
				ldb tmp = 0;
				for (int j = 0, sign = 1; j < i; ++j, sign *= -1)
					tmp += sign * cnk[i][j] * pw[i - j][x];
				res += tmp * (cnk[n][i] - ::ans[0][0][i]) / pw[n][x];
			}
		for (int a = 1; a <= n; ++a) {
			sum[a] = 0;
			for (int i = a, sign = 1; i <= n - 1; ++i, sign *= -1)
				sum[a] += (cnk[n][i] - ans[0][0][i]) * sign * cnk[i][a];
			sum[a] *= pw[a][n] / pw[n][n];
		}
		for (int x = n; x < LIMIT; ++x) {
			ldb cur = 0;
			for (int a = 1; a <= n; ++a) {
				cur += sum[a];
				sum[a] *= (a / (ldb) n);
			}
			res += cur;
			//cout << cur << endl;
		}
		cout << "Case #" << it + 1 << ": " << res << endl;
	}
	return 0;
}