#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int M = 1e9 + 7;

int power(int a, int b) {
	int res = 1;
	while (b) {
		if (b & 1)
			res = (1ll * res * a) % M;
		a = (1ll * a * a) % M;
		b /= 2;
	}
	return res;
}

int f(int n, int k) {
	return (1ll * k * power(k - 1, n - 1)) % M;
}

int inv(int a) {
	return power(a, M - 2);
}

const int N = 1e6 + 100;

int ik[N];

void solve(int c)
{
	int n, m, k; cin >> n >> m >> k;
	int ans = 0;
	int curc = 1;
	for (int i = k; i >= 2; i--)
	{
		int s = ((i - k) & 1) ? -1 : 1;
		ans = (ans + s * f(n, i) * 1ll * curc % M + M) % M;
		curc = (((curc * 1ll * i) % M) * ik[k - i + 1]) % M;
	}
	cout << "Case #" << c + 1 << ": " << ans << endl;
}

int main() {
#ifdef LOCAL42
#define TASK "F"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	for (int i = 1; i < N; i++)
		ik[i] = inv(i);
	int t; cin >> t;
	for (int i = 0; i < t; i++) {
		solve(i);
	}
	return 0;
}
