#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int num[128];
vector<int> ve[128];
int rev[128];
int used[128];

void test(int T) {
  int n; cin >> n;
  FOR(i, 0, n) cin >> num[i];
  FOR(i, 0, n) ve[i].clear(), rev[i] = 0, used[i] = 1;
  int nrev = 0;
  FOR(i, 0, n) FOR(j, i + 1, n) {
    if (num[i] > num[j]) {
      ve[i].push_back(j);
      ve[j].push_back(i);
      rev[i]++;
      rev[j]++;
      nrev++;
    }
  }
  double best = double(nrev) / double(n);
  ROF(z, 1, n) {
    int bad = -1;
    FOR(i, 0, n) {
      if (used[i] && (bad < 0 || rev[i] < rev[bad])) {
        bad = i;
      }
    }
    nrev -= rev[bad];
    used[bad] = 0;
    for (int j : ve[bad]) {
      rev[j]--;
    }
    best = max(best, double(nrev) / double(z));
  }
  cout << "Case #" << T + 1 << ": " << fixed << best << "\n";
}

int main() {
  int T;
  cin >> T;
  cout.precision(9);
  FOR(i, 0, T) test(i);
  return 0;
}
