#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

LL get(LL a, LL b) {
  if (a < b) swap(a, b);
  if (b == 0) {
    return (a == 0 ? 1 : 2);
  }
  if (a % b == 0) {
    return a / b + 1;
  }
  LL q = a / b;
  return q + get(b, a - q * b);
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(i, 0, T) {
    LL a, b;
    scanf("%lld%lld", &a, &b);
    printf("Case #%d: %lld\n", i + 1, get(a, b));
  }
  return 0;
}
