#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXK = 1000 * 1000 + 5, MOD = 1000 * 1000 * 1000 + 7;
int c[MAXK];

pair<int, int> gcd(int a, int b) {
    if(!b)
        return make_pair(1, 0);
    pair<int, int> p = gcd(b, a % b);
    return make_pair(p.second, p.first - (a / b) * p.second);
}

int inv(int x) {
    return (gcd(x, MOD).first + MOD) % MOD;
}

int powMod(int x, int p) {
    int res = 1;
    while(p) {
        if(p & 1)
            res = ((long long)res * x) % MOD;
        p >>= 1;
        x = ((long long)x * x) % MOD;
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n, m, k;
        cin >> n >> m >> k;
        if(k == 1) {
            cout << "Case #" << tt + 1 << ": " << (n == 1? m : 0) << '\n';
            continue;
        }
        c[0] = 1;
        for(int i = 1; i <= k; i++)
            c[i] = ((((long long)c[i - 1] * (m - i + 1)) % MOD) * inv(i)) % MOD;
        int ans = (((long long)k * powMod(k - 1, n - 1)) % MOD) -
                  (((long long)(k - 1) * powMod(k - 2, n - 1)) % MOD);
        ans = ((ans % MOD) + MOD) % MOD;
        ans = (long long)ans * c[k] % MOD;
        cout << "Case #" << tt + 1 << ": " << ans << '\n';
    }
    return 0;
}
