#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 105, MAXV = 2 * MAXN * MAXN;
int win[MAXV], cnt[MAXV];
vector<int> g[MAXV], gr[MAXV];

int main()
{
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        int vs = 2 * n * n + 1;
        for(int i = 0; i < vs; i++) {
            g[i].clear();
            gr[i].clear();
        }
        for(int i = 0; i < m; i++) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            for(int j = 0; j < n; j++)
                if(j != v) {
                    g[2 * (v + j * n)].push_back(2 * (u + j * n) + 1);
                    gr[2 * (u + j * n) + 1].push_back(2 * (v + j * n));
                    g[2 * (j + v * n) + 1].push_back(2 * (j + u * n));
                    gr[2 * (j + u * n)].push_back(2 * (j + v * n) + 1);
                }
        }
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        for(int i = 0; i < n; i++) {
            g[2 * (i + i * n) + 1].push_back(vs - 1);
            gr[vs - 1].push_back(2 * (i + i * n) + 1);
        }
        for(int i = 0; i < vs; i++)
            win[i] = -1;
        for(int i = 0; i < vs; i++)
            cnt[i] = g[i].size();
        queue<int> q;
        for(int i = 0; i < vs; i++)
            if(!cnt[i]) {
                win[i] = 0;
                q.push(i);
            }
        while(!q.empty()) {
            int v = q.front();
            q.pop();
            for(size_t i = 0; i < gr[v].size(); i++) {
                int u = gr[v][i];
                if(win[u] != -1)
                    continue;
                if(win[v]) {
                    cnt[u]--;
                    if(!cnt[u]) {
                        win[u] = 0;
                        q.push(u);
                    }
                }
                else {
                    win[u] = 1;
                    q.push(u);
                }
            }
        }
        cout << "Case #" << tt + 1 << ": " << (win[2 * (x + y * n)] == 0? "No" : "Yes") << '\n';
    }
    return 0;
}
