#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;

const int MAX_F = 50;

ll fibs[MAX_F];

ll gcd(ll a, ll b)
{
    return b == 0 ? a : gcd(b, a % b);
}

ll gcd_ex(ll a, ll b, ll &x, ll &y)
{
    if (b == 0)
    {
        x = 1;
        y = 0;
        return a;
    }

    ll x1, y1;
    ll d = gcd_ex(b, a % b, x1, y1);
    x = y1;
    y = x1 - (a / b) * y1;
    return d;
}

bool solve_diof(ll a, ll b, ll c, ll &x, ll &y)
{
    ll gc = gcd(a, b);
    if (c % gc != 0)
    {
        return false;
    }

    a /= gc;
    b /= gc;
    c /= gc;

    ll gex = gcd_ex(a, b, x, y);
    x *= c;
    y *= c;

    ll k = -x / b + 1;
    x += k * b;
    y -= k * a;
    if (y < 0)
    {
        k = -y / a + 1;
        x -= k * b;
        y += k * a;

        if (x > y)
        {
            k = (x - y + a + b - 1) / (a + b);
            x -= k * b;
            y += k * a;
        }

        if (x <= 0 || y <= 0)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int tests;
	cin >> tests;

	for (int tc = 0; tc < tests; ++tc)
	{
		int n;
		cin >> n;
		bool good = true;
		for (int i = 0; i < n; ++i)
		{
			int k;
			cin >> k;
			if (k % 3 != 0)
			{
				good = false;
			}
		}

		cout << "Case #" << tc + 1 << ": ";
		if (good)
		{
			cout << "Yes";
		}
		else
		{
			cout << "No";
		}
		cout << endl;
	}

    return 0;
}