#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair

vector<long long> dnp(1000001);


long long binpow(long long a, long long p){
	if(!p)return 1;
	if(p%2)return (a*binpow(a,p-1))%MOD;
	long long t = binpow(a,p/2);
	return (t*t)%MOD;
}

long long inv(long long w){
	return binpow(w, MOD-2);
}


long long C(long long n, long long k){
	if(n-k < k)return C(n, n-k);
	long long res=1;
	for(int i=0; i<k; ++i){
		res *= (n-i);
		res %= MOD;
	}
	res*=dnp[k];
	return res%MOD;
}


long long ans(long long n, long long m, long long k){
	return (((C(m,k)*k)%MOD)*binpow(k-1, n-1))%MOD;
}

int main(){
	//freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	dnp[1]=1;
	for(int i=2; i<=1000000; ++i){
		dnp[i]=dnp[i-1]*inv(i);
		dnp[i]%=MOD;
	}
	int tes;
	cin>>tes;
	for(int TT=0;TT<tes;++TT){
		long long n,m,k;
		cin>>n>>m>>k;
		printf("Case #%d: ", TT+1);
		cout<<ans(n,m,k)<<endl;
	}

	return 0;
}