#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair

long long binpow(long long a, long long p){
	if(!p)return 1;
	if(p%2)return (a*binpow(a,p-1))%MOD;
	long long t = binpow(a,p/2);
	return (t*t)%MOD;
}

vector<long long>in(1000001);

long long inv(long long w){
	return binpow(w, MOD-2);
}

map<pair<int,int>,long long>cc;

long long C(long long n, long long k){
	if(!k)return 1;
	if(k>n)return 0;
	if(n-k < k)return C(n, n-k);
	if (cc.count(mp(n,k))) return cc[mp(n,k)];
	long long res=1;
	for(int i=0; i<k; ++i){
		res *= (n-i);
		res %= MOD;
	}
	res *= inv(in[k]);
	/*for(int i=2; i<=k; ++i){
		res *= inv(i);
	}*/
	cc[mp(n,k)] = res;
	return res%MOD;
}


long long ans(long long n, long long m, long long k){
	if(n==1){
		return m;
	}
	long long res=0;
	int l = 1;
	for(int i = 0; i<=k-2; i++) {
		res+=((((k-i)*binpow(k-i-1,n-1)%MOD)%MOD)*l*C(k,i))%MOD;
		l*=-1;
	}
	while(res<0){
		res+=MOD;
	}
	res*=C(m,k);
	res%=MOD;
	return res;
}

int main(){
	//freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int tes;
	cin>>tes;

	in[1]=1;
	for(int i=2; i<=1000000; ++i){
		in[i]=i*in[i-1];
		in[i]%=MOD;
	}

	for(int TT=0;TT<tes;++TT){
		long long n,m,k;
		cin>>n>>m>>k;
		printf("Case #%d: ", TT+1);
		cout<<ans(n,m,k)<<endl;
	}

	return 0;
}