#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
#define MOD 10007
#define mp make_pair

int n;

set<pair<long long, int> >ss;
set<pair<long long, int> >mains;

struct ip{
	int a,b,c,d,e;
	ip(){};
	ip(long long v, int h){
		e = h;
		v <<= (32-e);
		long long mask = (1<<8)-1;
		d = v&mask;
		v>>=8;
		c=v&mask;
		v>>=8;
		b=v&mask;
		v>>=8;
		a=v&mask;
	}
};

void mark(long long v, int h){
	bool ok=true;
	long long w=v;
	int hh=h;
	v/=2;
	h--;
	while(v){
		if(ss.count(make_pair(v,h))){
			ok=false;
			break;
		}
		v/=2;
		h--;
	}
	if(ok){
		mains.insert(make_pair(w,hh));
	}
}

long long getv(ip w){
	long long res=1;
	res<<=8;
	res+=w.a;
	res <<= 8;
	res+=w.b;
	res <<= 8;
	res+=w.c;
	res <<= 8;
	res+=w.d;

	res>>=(32-w.e);
	return res;
}

vector<ip>ans;

bool go(long long v, int h){
	if(ss.count(make_pair(v,h)))return false;
	if(v >= ((long long)(1)<<32)){
		return (!ss.count(make_pair(v,h)));
	}
	bool x=go(2*v,h+1);
	bool y=go(2*v+1,h+1);
	if(x&y){
		return true;
	}
	if(!x && !y){
		return false;
	}
	if(x && !y){
		ans.push_back(ip(2*v, h+1));
		return false;
	}
	if(!x && y){
		ans.push_back(ip(2*v+1, h+1));
		return false;
	}
}

int main(){
	//freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int tes;
	cin>>tes;
	for(int TT=0;TT<tes;++TT){
		ans.clear();
		ss.clear();
		mains.clear();
		cin>>n;
		if(!n){
			ans.push_back(ip(0,0));
		}
		ip crr;
		for(int i=0; i<n; ++i){
			scanf("%d.%d.%d.%d/%d", &crr.a,&crr.b,&crr.c,&crr.d,&crr.e);
			ss.insert(make_pair(getv(crr), crr.e));
		}
		for(set<pair<long long,int>>::iterator it = ss.begin(); it!=ss.end(); ++it){
			mark(it->first, it->second);
		}

		set<pair<int,long long>, greater<pair<int,long long>>>q;

		for(set<pair<long long, int>>::iterator it = mains.begin(); it!=mains.end(); ++it){
			q.insert(make_pair(it->second, it->first));
		}


		pair<int,long long>curr;

		while(!q.empty()){
			curr = *q.begin();
			q.erase(q.begin());
			if(curr.second==1)break;
			if(ss.count(make_pair(curr.second ^ (long long)(1), curr.first))){
				q.erase(make_pair(curr.first, curr.second ^ (long long)(1)));
				ss.insert(make_pair(curr.second/2, curr.first-1));
			}
			else{
				ans.push_back(ip(curr.second ^ (long long)(1), curr.first));
			}
			q.insert(make_pair(curr.first-1, curr.second/2));
		}


		printf("Case #%d:\n", TT+1);
		cout<<ans.size() << endl;
		for(int i=0; i<ans.size(); ++i){
			printf("%d.%d.%d.%d/%d\n", ans[i].a,ans[i].b,ans[i].c,ans[i].d,ans[i].e);
		}
	}
	return 0;
}