#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

long long gcd(long long a, long long b) {
    return b == 0 ? a : gcd(b, a % b);
}

int main() {
    int ts;
    cin >> ts;
    for (int t = 0; t < ts; t++) {
        long long a, b;
        cin >> a >> b;
        cout << "Case #" << (t+1) << ": ";
        if (a == 0 && b == 0) {
            cout << 1 << endl;
        } else if (a == 0 || b == 0) {
            cout << 2 << endl;
        } else if (a < b) {
            cout << max(a, b - a) / gcd(a, b) + 2 << endl;
        } else if (b < a) {
            cout << max(b, a - b) / gcd(a, b) + 2 << endl;
        } else {
            cout << 2 << endl;
        }
    }

    return 0;
}
