#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n, m, k;

bool read() {
	if (scanf("%d %d %d", &n, &m, &k) != 3)
		return false;
	return true;
}

int binpow(int a, int b, int m) {
	li res = 1, cur = a;

	for (int i = 0; (1 << i) <= b; ++i) {
		if (b & (1 << i))
			res = (res * cur) % m;
		cur = (cur * cur) % m;
	}

	return res;
}

const int MOD = int(1e9) + 7;

void solve() {
	if (k == 1) {
		if (n == 1)
			printf("%d\n", m);
		else
			puts("0");
		return;
	}
	
	int C = 1;
	forn(i, k)
		C = (li(C) * (m - i)) % MOD;

	int d = 1;
	forn(i, k)
		d = (li(d) * (i + 1)) % MOD;

	C = (li(C) * binpow(d, MOD - 2, MOD)) % MOD;

	int res = C;

	C = 1;
	int sum = 0;
	forn(i, k) {
		if (i) {
			C = (li(C) * (k - i + 1)) % MOD;
			C = (li(C) * binpow(i, MOD - 2, MOD)) % MOD;
		}

		li cur = ((((i & 1) ? -1 : +1) * C) % MOD + MOD) % MOD;
		cur = (cur * (k - i)) % MOD;
		cur = (cur * binpow(k - i - 1, n - 1, MOD)) % MOD;
		sum = (sum + cur) % MOD;
	}

	res = (li(res) * sum) % MOD;

	printf("%d\n", res);

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	forn(i, t) {
		assert(read());
		printf("Case #%d: ", i + 1);
		solve();
	}

	return 0;
}