#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define MOD 1000000007
using namespace std;

inline int LgPut(int baz, int put)
{
    int rez = 1;
    while(put)
    {
        if(put % 2 == 1)
        {
            rez = (1LL * rez * baz) % MOD;
            put--;
        }
        baz = (1LL * baz * baz) % MOD;
        put /= 2;
    }
    return rez;
}

inline int Solve(int n, int k)
{
    if(k == 0)
        return 0;
    if(k == 1)
    {
        if(n == 1)
            return 1;
        return 0;
    }
    if(n == 1)
        return k;
    int rez = k;
    rez = (1LL * rez * LgPut(k - 1, n - 1)) % MOD;
    return rez;
}

int T, n, m, K, inv[1000100];

int main ()
{
#ifdef local
    freopen ("f.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, t, comb;
    for(i = 1; i <= 1000010; ++i)
        inv[i] = LgPut(i, MOD - 2);
    cin >> T;
    for(t = 1; t <= T; ++t)
    {
        cin >> n >> m >> K;
        int sol = Solve(n, K) - Solve(n, K - 1);
        if(sol < 0)
            sol += MOD;
        if(sol >= MOD)
            sol -= MOD;
        comb = 1;
        for(i = 1; i <= K; ++i)
        {
            comb = (1LL * comb * (m - i + 1)) % MOD;
            comb = (1LL * comb * inv[i]) % MOD;
        }
        sol = (1LL * sol * comb) % MOD;
        cout << "Case #" << t << ": " << sol << "\n";
    }
    return 0;
}
