#include <iostream>
#include <cstdio>
#include <unordered_set>
#include <tuple>
#include <cmath>

using namespace std;

typedef long long int Z;

int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
		
	for(int te = 0; te < Te; ++te) {
		Z A;
		Z B;
		cin >> A >> B;
		
		unordered_set<Z> seen;
		seen.insert(A);
		seen.insert(B);
		
		while(B != 0) {
			tie(A, B) = make_tuple(B, abs(A - B));
			seen.insert(B);
		}
		
		cout << "Case #" << te + 1 << ": " << seen.size() << "\n";
	}
	
	return 0;
}
