#include <iostream>
#include <cstdio>
#include <unordered_set>
#include <tuple>
#include <cmath>

using namespace std;

typedef long long int Z;

Z F(Z A, Z B) {
	if(A == B) {
		if(A == 0) return 1;
		return 2;
	}
	
	if(A > B) {
		Z C = A % B;
		Z K = A / B;
		if(C == 0) return K + 1;
		if(K & 1) {
			return K + F(B, C);
		} else {
			return K + F(C, B);
		}
	} else {
		Z C = B % A;
		Z K = B / A;
		if(C == 0) return K + 1;
		if(K & 1) {
			return K + F(C, A);
		} else {
			return K + F(A, C);
		}
	}
	
}

int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
		
	for(int te = 0; te < Te; ++te) {
		Z A;
		Z B;
		cin >> A >> B;
		
		cout << "Case #" << te + 1 << ": " << F(A, B) << "\n";
	}
	
	return 0;
}
