#include <stdio.h>
#include <iostream>

using namespace std;

const int BASE = 1000000007;
const int N = 1111111;

int tt, cur, n, m, k;
int rev[N];

int pw(int x, int n) {
	int res = 1;
	while (n) {
		if (n % 2) {
			res = (res * 1LL * x) % BASE;
		}
		x = (x * 1LL * x) % BASE;
		n /= 2;
	}
	return res;
}

int f(int n, int m, int k) {
	if (k == 0) return 0;
	int res = pw(k - 1, n - 1);
	res = (res * 1LL * k) % BASE;
	return res;
}

int main() {
	freopen("input.txt", "r", stdin);
	rev[0] = 1;
	for (int i = 1; i < N; i++) rev[i] = (rev[i - 1] * 1LL * pw(i, BASE - 2)) % BASE;
	scanf("%d", &tt);
	while (tt--) {
		cur++;
		cout << "Case #" << cur << ": ";
		scanf("%d%d%d", &n, &m, &k);
		int ans = (f(n, m, k) - f(n, m, k - 1) + BASE) % BASE;
		//C(m, k)
		for (int i = m - k + 1; i <= m; i++) ans = (ans * 1LL * i) % BASE;
		ans = (ans * 1LL * rev[k]) % BASE;
		printf("%d\n", ans);
	}
}