#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 111;

int was[N][N][2], tt, n, m;
bool used[N][N][2];
vector<int> g[N];

void solve(int x, int y, int cur) {
	if (used[x][y][cur]) return;
	used[x][y][cur] = true;
	if (x == y) {
		if (cur == 0) {
			was[x][y][cur] = -1;
		} else {
			was[x][y][cur] = +1;
		}
		return;
	}
	if (cur == 0) {
		was[x][y][cur] = -1;
		for (int i = 0; i < g[x].size(); i++) {
			int e = g[x][i];
			solve(e, y, cur ^ 1);
			if (was[e][y][cur ^ 1] != 1) {
				was[x][y][cur] = +1;
				return;
			}
		}
	} else {
		was[x][y][cur] = -1;
		for (int i = 0; i < g[y].size(); i++) {
			int e = g[y][i];
			solve(x, e, cur ^ 1);
			if (was[x][e][cur ^ 1] == -1) {
				was[x][e][cur ^ 1] = +1;
				return;
			}
		}
	}
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &tt);
	int cur = 0;
	while (tt--) {
		cur++;
		printf("Case #%d: ", cur);
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; i++) g[i].clear();
		for (int i = 0; i < m; i++) {
			int x, y;
			scanf("%d%d", &x, &y);
			--x;
			--y;
			g[x].push_back(y);
		}
		int sx, sy;
		memset(was, false, sizeof(was));
		memset(used, false, sizeof(used));
		scanf("%d%d", &sx, &sy);
		solve(sx, sy, 0);
		if (was[sx][sy][0] != -1) {
			puts("Yes");
		} else puts("No");
	}
}