#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 

typedef unsigned int uint;

using namespace std;


const int N = -1;
const int INF = 1e9;

struct node {
	node *next[2];
	bool flag;
	node() {
		memset(next, 0, sizeof(next));
	}
};

node * head;
vector < pair < uint, int > > answer;

void print(uint a) {
	//cerr << "a: " << a << endl;
	for (int i = 24; i >= 0; i -= 8) {
		cout << ((a >> i) & ((1 << 8) - 1));
		if (i != 0) cout << ".";
	}
}
int cntN;

void add(uint mask, int l) {
	node * v = head;
	//cerr << "l: " << l << endl;
	for (int i = 0; i < l; i++) {
		//cerr << "sdf\n";
		int ch = (mask >> (31 - i)) & 1;
		//cerr << "ch:
		if (v->next[ch] == NULL) {
			v->next[ch] = new node;							
			cntN++;
			//cerr << "newwwwwww\n";
		}
		v = v->next[ch];
	}
	v->flag = 1;
}

void dfs(node * v, uint mask, int pos) {
	if (v->flag == 1) return;
	for (int i = 0; i < 2; i++) {
		//cerr << "v : " <<
		uint newMask = mask | (uint(i) << pos); 
		//cerr << "i pos nmask: " << i << " " << pos << " " << newMask << endl;
		if (v->next[i] == NULL) {
			answer.pb(mp(newMask, 32 - pos));	
		}
		else {
			assert(v->next[i] != NULL);
			dfs(v->next[i], newMask, pos - 1);
		}
	}
}


int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	int T;
	scanf("%d", &T);
	for (int tt = 1; tt <= T; tt++) {
		int n;
		scanf("%d", &n);
		head = new node;
		bool flagLZ = 0;
		printf("Case #%d:\n", tt);
		for (int i = 0; i < n; i++) {
			int a, b, c, d, l;
			scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &l);
			flagLZ |= l == 0;
			uint mask = (uint(a) << 24) | (uint(b) << 16) | (uint(c) << 8) | (uint(d));
			//cerr << "sdf\n";
			add(mask, l);
			//cerr << sdf
		}
		//cerr << "cntN: " << cntN << endl;
		//return 0;
		if (flagLZ) {
			printf("0\n");
			continue;
		}
		if (n == 0) {
			printf("1\n");
			printf("0.0.0.0/0\n");
			continue;
		}
		answer.clear();
		dfs(head, 0u, 31);
		printf("%d\n", (int)answer.size());
		for (auto x: answer) {
			print(x.fr);
			printf("/%d\n", x.sc);
		}
	}
	return 0;
}

