#if 1
#include <cstring>
#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;

const int maxn = 100;
int color [maxn][maxn];
int win[maxn][maxn];

void upd(int &v, int newv)
{
	if(v == 0) v = newv;
	else if(v == 2 && newv == 1) v = newv;
}

int dfs(int a, int b, int who, vvi &g)
{
	if(color[a][b] == 1) return 2;
	if(color[a][b] == 2) return win[a][b];
	color[a][b] = 1;

	int v = who ? b : a;
	int w = 0;
	for (int i = 0; i < g[v].size(); ++i)
	{
		int to = g[v][i];
		if(who)
		{
			if(to == a) 
				continue;
		}
		else
		{
			if(to == b)
			{
				upd(w, 1);
				continue;
			}
		}

		int loww;
		if(who) loww = dfs(a, to, !who, g);
		else loww = dfs(to, b, !who, g);

		//[main]
		if(who)
		{
			if(loww == 0) upd(w, 1);
			if(loww == 2) upd(w, 1);
		}
		else
		{
			if(loww == 0) upd(w, 1);
		}
	}

	win[a][b] = w;
	color[a][b] = 2;
	return w;
}

using namespace std;
int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int T; scanf("%d", &T);
	for (int t = 1; t <= T; ++t)
	{
		memset(win, 0, sizeof(win));
		memset(color, 0, sizeof(color));
		int n, m; scanf("%d%d", &n, &m);
		vvi g(n);
		for (int i = 0; i < m; ++i)
		{
			int b, e; scanf("%d%d", &b, &e); --b; --e;
			g[b].push_back(e);
		}
		int x, y; scanf("%d%d", &x, &y); --x; --y;
		int w = dfs(y, x, 1, g);
		
		printf("Case #%d: %s\n", t, (w > 0) ? "Yes" : "No");
	}
	return 0;
}
#endif 	