#include<cstdlib>

#include<iostream>
#include<fstream>
#include<sstream>

#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>

#include<cmath>
#include<algorithm>
#include<limits>

using namespace std;

#define fi(i, a, b) for (int i = a; i < b; i++)

struct node{
	int num;
	vector<node*> to;
	vector<node*>from;
	bool comes[2][102];
	int bob, alice;
	bool noway;
	bool important;
};

node g[100];
		int x,y,n,m;

void gofrom(node* p){
	p->important = false;
	p->noway=true;
	fi(i,0,p->from.size()){
		vector<node*> &ways = p->from[i]->to;
		bool good = false;
		fi(j,0,ways.size()){
			if(!ways[j]->noway){ good = true; break;}
		}
		if(good)
			p->from[i]->important=true;
		else{
			gofrom(p->from[i]);
		}
	}
}

//-------------------------------------------------
int come(int bob){
	int turn =0;
	while(turn<=n){
		fi(i,0,n){
			bool motion = false;
			//if(bob==0 && !g[i].noway && turn!=0) return -100; //win
			if(g[i].comes[bob][turn]==false) continue;

			fi(j,0,g[i].to.size()){
				bool ok = true;
				if(bob==0){
					if(g[i].to[j]->comes[1][turn] || g[i].to[j]->comes[1][turn+1]) ok = false;
				}

				if(ok){
					g[i].to[j]->comes[bob][turn+1]=true; motion = true;
				}
			}
			if(!motion)
				return turn;
		}
		turn++;
	}
	return turn;
}

void wide(bool bob, node* p){
	queue<node*> q;
	q.push(p);

	bool remember=false; node* rem;
	if(bob){
		fi(i,0,p->to.size()){
			if(p->to[i]->num==y+1){remember = true; rem = p->to[i]; p->to.erase(p->to.begin()+i);}
		}
	}

	int c = 1;
	int cur = 0;
	if(bob) p->bob = 0; else p->alice=0;
	while(c>0){
		if(cur==1 && remember) p->to.push_back(rem);
		cur++;
		fi(i,0,c){
			node* x = q.front(); q.pop();
			fi(j,0,x->to.size()){
				if(bob && x->to[i]->bob == 1000) {
					x->to[i]->bob=cur;
					q.push(x->to[i]);
				}
				if(!bob && x->to[i]->alice == 1000) {
					x->to[i]->alice=cur;
					q.push(x->to[i]);
				}
			}
		}
		c=q.size();
	}

}

int main()
{
#if defined (DEBUG) || defined (_DEBUG)
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif

	int tests;
	cin>>tests;
	fi(tt,0,tests){
		cin>>n>>m;
		fi(i,0,n) {g[i] = node(); g[i].noway=false; g[i].important=false; g[i].num=i+1; g[i].bob=1000; g[i].alice=1000; fi(j,0,102){  g[i].comes[0][j]=false; g[i].comes[1][j]=false;}}
		fi(i,0,m){
			int a,b;
			cin>>a>>b;
			a--,b--;
			g[a].to.push_back(&g[b]);
		}
		cin>>x>>y; x--; y--;

		g[x].comes[0][0]=true;
		g[y].comes[1][0]=true;

		fi(i,0,n){
			fi(j,0,g[i].to.size())
				g[i].to[j]->from.push_back(&g[i]);
		}

		fi(i,0,n){
			if(g[i].to.size()==0)
				gofrom(&g[i]);
		}

		int alice=come(1), bob = come(0);
		if(bob==n){
			cout<<"Case #"<<tt+1<<": "<<"Yes"<<endl;
		}
		else{
			cout<<"Case #"<<tt+1<<": "<<(bob>alice? "Yes": "No")<<endl;
		}

		/*
		wide(true,&g[x]);
		wide(false, &g[y]);

		if(!g[x].noway){
			bool found=false;
				fi(i,0,g[x].to.size()){
					if(g[x].to[i]->num != y+1 &&  !g[x].to[i]->noway ) {
						found=true; break;
					}
				}
				cout<<"Case #"<<tt+1<<": "<< (found? "Yes":"No")<<endl;
		}
		else if(g[x].alice==1000) {
			int bobmax=0, alicemax=0;
			fi(i,0,n){
				if(g[i].bob > bobmax && g[i].bob!=1000) bobmax=g[i].bob;
				if(g[i].alice > alicemax && g[i].alice!=1000) alicemax=g[i].alice;
			}
			cout<<"Case #"<<tt+1<<": "<< (bobmax>alicemax? "Yes":"No")<<endl;
		}
		else{
			bool ok=false;
			fi(i,0,n){
				if(g[i].important && g[i].bob < g[i].alice){ cout<<"Case #"<<tt+1<<": "<<"Yes"<<endl; ok = true; break;}
			}
			if(!ok) cout<<"Case #"<<tt+1<<": "<<"No"<<endl;
		}*/
	}

	return 0;
}