#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include "testlib.h"


using namespace std;

const int maxlen=9;
const int dx[4]={-1,0,0,1},dy[4]={0,-1,1,0};

struct sol
{
  int sx,sy,x,y,len,com,tot;
  int r[20];
};

char o[150][10][10],a[10][10];
char s[500];
string ss;
int mark[100][100];
sol answ[150],usr;

bool inrange(int x,int y)
{
  return ((x>0)&&(x<6)&&(y>0)&&(y<7));
}

void floodfill(int x,int y,int c,int v)
{
  mark[x][y]=v;
  for(int i=0;i<4;++i)
  {
    int j=x+dx[i],k=y+dy[i];
    if((inrange(j,k))&&(mark[j][k]==c))
      floodfill(j,k,c,v);
  }
}

void checksol(sol& now)
{
  int j=now.sx,k=now.sy,nj,nk;
  for(int i=1;i<=now.len;++i)
  {
    nj=j+dx[now.r[i]];
    nk=k+dy[now.r[i]];
    swap(a[j][k],a[nj][nk]);
    j=nj;
    k=nk;
  }
  now.com=now.tot=0;
  bool flag;
  do
  {
    flag=false;
    memset(mark,0,sizeof(mark));
    int cnt=0;
    for(int i=1;i<6;++i)
    {
      for(int j=3;j<7;++j)
      {
        if(a[i][j]=='.')
          continue;
        if((a[i][j-2]==a[i][j])&&(a[i][j-1]==a[i][j]))
        {
          if(!flag)
            flag=true;
          if(mark[i][j-2]==0)
          {
            mark[i][j-2]=mark[i][j-1]=mark[i][j]=++cnt;
          }
          else
            mark[i][j]=mark[i][j-2];
        }
      }
    }
    int col=cnt;
    if(flag)
    {
      for(int i=2;i<6;++i)
      {
        for(int j=1;j<7;++j)
        {
          if(a[i][j]=='.')
            continue;
          if((a[i-1][j]==a[i][j])&&(mark[i-1][j]>0)&&(mark[i][j]>0)&&(mark[i-1][j]!=mark[i][j]))
          {
            floodfill(i,j,mark[i][j],mark[i-1][j]);
            --cnt;
          }
        }
      }
    }
    for(int i=2;i<5;++i)
    {
      for(int j=1;j<7;++j)
      {
        if(a[i][j]=='.')
          continue;
        if((a[i-1][j]==a[i][j])&&(a[i+1][j]==a[i][j]))
        {
          if(!flag)
            flag=true;
          if((mark[i-1][j]==0)&&(mark[i][j]==0)&&(mark[i+1][j]==0))
          {
            mark[i-1][j]=mark[i][j]=mark[i+1][j]=++col;
            ++cnt;
          }
          else
          {
            int val=50;
            if((mark[i-1][j]>0)&&(mark[i-1][j]<val))
              val=mark[i-1][j];
            if((mark[i][j]>0)&&(mark[i][j]<val))
              val=mark[i][j];
            if((mark[i+1][j]>0)&&(mark[i+1][j]<val))
              val=mark[i+1][j];
            if(mark[i-1][j]==0)
              mark[i-1][j]=val;
            else if(mark[i-1][j]!=val)
            {
              floodfill(i-1,j,mark[i-1][j],val);
              --cnt;
            }
            if(mark[i][j]==0)
              mark[i][j]=val;
            else if(mark[i][j]!=val)
            {
              floodfill(i,j,mark[i][j],val);
              --cnt;
            }
            if(mark[i+1][j]==0)
              mark[i+1][j]=val;
            else if(mark[i+1][j]!=val)
            {
              floodfill(i+1,j,mark[i+1][j],val);
              --cnt;
            }
          }
        }
      }
    }
    if(flag)
    {
      for(int i=1;i<6;++i)
      {
        for(int j=2;j<7;++j)
        {
          if(a[i][j]=='.')
            continue;
          if((a[i][j-1]==a[i][j])&&(mark[i][j-1]>0)&&(mark[i][j]>0)&&(mark[i][j-1]!=mark[i][j]))
          {
            floodfill(i,j,mark[i][j],mark[i][j-1]);
            --cnt;
          }
        }
      }
    }
    now.com+=cnt;
    for(int j=1;j<7;++j)
    {
      for(int i=1;i<6;++i)
      {
        if(mark[i][j]>0)
        {
          ++now.tot;
          for(int k=i;k>0;--k)
          {
            if(a[k][j]=='.')
              break;
            a[k][j]=a[k-1][j];
          }
        }
      }
    }
  }while(flag);
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);
  //
  //FILE* f=freopen("pad.in","r",stdin);
  int t;
  t=inf.readInt();
  memset(o,'.',sizeof(o));
  for(int cnt=1;cnt<=t;++cnt)
  {
    for(int i=1;i<6;++i)
    {
     ss=inf.readToken();
      sscanf (ss.c_str(),"%s",o[cnt][i]+1);
    }
  }
  //fclose(f);

  //׼
  //f=freopen("pad.ans","r",stdin);
  for(int cnt=1;cnt<=t;++cnt)
  {
    ss=ans.readToken();
    ss=ans.readToken();
    ss=ans.readToken();
    strncpy(s,ss.c_str(),499);
    answ[cnt].com=0;
    for(int i=6;i<(int)strlen(s);++i)
      answ[cnt].com=answ[cnt].com*10+s[i]-'0';
    ss=ans.readToken();strncpy(s,ss.c_str(),499);
    answ[cnt].len=0;
    for(int i=7;i<(int)strlen(s);++i)
      answ[cnt].len=answ[cnt].len*10+s[i]-'0';
    answ[cnt].sx=ans.readInt();
    answ[cnt].sy=ans.readInt();
    ss=ans.readToken();strncpy(s,ss.c_str(),499);
    for(int i=0;i<(int)strlen(s);++i)
    {
      if(s[i]=='U')
        answ[cnt].r[i+1]=0;
      if(s[i]=='L')
        answ[cnt].r[i+1]=1;
      if(s[i]=='R')
        answ[cnt].r[i+1]=2;
      if(s[i]=='D')
        answ[cnt].r[i+1]=3;
    }
    memcpy(a,o[cnt],sizeof(o[cnt]));
    checksol(answ[cnt]);
  }
  //fclose(f);

  //벢жû
  //f=freopen("pad.out","r",stdin);
  for(int cnt=1;cnt<=t;++cnt)
  {
    int cas;
    bool flag=true;
    ss=ouf.readToken();strncpy(s,ss.c_str(),499);
    if(strcmp(s,"Case")!=0) quitf(_pe,"Case needed!");
    ss=ouf.readToken();strncpy(s,ss.c_str(),499);
    if(s[0] != '#') quitf(_pe,"# needed!");
    sscanf (s,"#%d",&cas);
    if(cas!=cnt) quitf(_pe,"Wrong Case ID");
    ss=ouf.readToken();strncpy(s,ss.c_str(),499);
    int ucom=0;
    for(int i=6;i<(int)strlen(s);++i)
      ucom=ucom*10+s[i]-'0';
    s[6]='\0';
    if(strcmp(s,"Combo:")!=0) quitf(_wa,"Combo needed");
    ss=ouf.readToken();strncpy(s,ss.c_str(),499);
    usr.len=0;
    for(int i=7;i<(int)strlen(s);++i)
      usr.len=usr.len*10+s[i]-'0';
    s[7]='\0';
    if(strcmp(s,"Length:")!=0) quitf(_wa,"Length needed");
    usr.sx=ouf.readInt();
    usr.sy=ouf.readInt();
    if(!inrange(usr.sx,usr.sy)) quitf (_wa,"X or Y are out of range");
    ss=ouf.readToken();strncpy(s,ss.c_str(),499);
    for(int i=0;i<(int)strlen(s);++i)
    {
      if(s[i]=='U')
        usr.r[i+1]=0;
      else if(s[i]=='L')
        usr.r[i+1]=1;
      else if(s[i]=='R')
        usr.r[i+1]=2;
      else if(s[i]=='D')
        usr.r[i+1]=3;
      else
        quitf(_pe,"Wrong Direction!");
    }
    if((int)strlen(s)!=usr.len)
      quitf(_wa,"Wrong Length");
    if(flag)
    {
      flag=false;
      memcpy(a,o[cnt],sizeof(o[cnt]));
      checksol(usr);
      if((usr.com==ucom)&&(usr.com==answ[cnt].com)&&(usr.tot==answ[cnt].tot)&&(usr.len==answ[cnt].len))
        flag=true;
    }
    if(flag)
      {}
    else
      quitf(_wa,"Inconsistent answer case %d",cnt);
  }
   quitf (_ok,"OK!");
}
