#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxn = 1000003;
ll fact[maxn];
ll inv[maxn];

ll binpow(ll x, ll st, ll mod)
{
	ll ans = 1;
	while (st)
	{
		if (st & 1)
			ans = (ans * x) % mod;
		x = (x * x) % mod;
		st >>= 1;
	}
	return ans;
}

ll getC(ll n, ll k, ll mod)
{
	ll ans = 1;
	for (ll i = 0; i < k; i++)
		ans = (ans * (n - i)) % mod;
	return (ans * binpow(fact[k], mod - 2, mod)) % mod;
}

ll getfC(ll n, ll k, ll mod)
{
	ll ans = fact[n];
	ans = (ans * inv[k]) % mod;
	ans = (ans * inv[n-k]) % mod;
	return ans;
}

ll f(ll k, ll n, ll mod)
{
	ll ans = (k * binpow(k - 1, n - 1, mod)) % mod; 
	return ans;
}

int main()
{
	//freopen("a.in", "r", stdin);
	ll mod = 1000000007;
	fact[0] = 1;
	for (int i = 1; i <= 1000000; i++)
		fact[i] = (fact[i-1] * i) % mod;
	inv[0] = 1;
	for (int i = 1; i <= 1000000; i++)
		inv[i] = binpow(fact[i], mod - 2, mod);
	int T;
	cin >> T;
	for (int g = 1; g <= T; g++)
	{
		ll n, m, k;
		cin >> n >> m >> k;
		ll ans1 = getC(m, k, mod);
		ll ans2 = 0;
		for (int i = k; i >= 1; i--)
		{
			ll cur = getfC(k, i, mod);
			cur = (cur * f(i, n, mod)) % mod;
			if ((k - i) % 2 == 0)
				ans2 += cur;
			else
				ans2 -= cur;
		}
		ans2 = ((ans2 % mod) + mod) % mod;
		ll ans = (ans1 * ans2) % mod;
		cout << "Case #" << g << ": " << ans << "\n";
	}
	return 0;
}