#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long

#define ull unsigned long long
#define uint unsigned int
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

struct node
{
	node *nxt[2];
	int bad;
	node()
	{
		nxt[0] = nxt[1] = NULL;
		bad = 0;
	}
}; 


vector < pair < uint, int > > ans;
void dfs(node *v, int len, uint mask)
{
	if (len == 32)
		return;

	if (v->bad)
		return;

	if (v->nxt[0] == NULL && v->nxt[1] == NULL)
	{
		if (len == 0)
			ans.pb(mp(mask, len));
		return;
	}
	
	if (v->nxt[0] == NULL)
	{
		ans.pb(mp(mask, len + 1));
	}
	else
		dfs(v->nxt[0], len + 1, mask);

	if (v->nxt[1] == NULL)
	{
		ans.pb(mp(mask ^ (((uint)1) << (31 - len)), len + 1));
	}
	else
		dfs(v->nxt[1], len + 1, mask ^ (((uint)1) << (31 - len)));
}

void out(uint x, int len)
{
	printf("%d.%d.%d.%d", (int)(x >> 24), (int)((x >> 16) & ((1LL << 8) - 1)), (int)((x >> 8) & ((1LL << 8) - 1)), (int)((x) & ((1LL << 8) - 1)));
	printf("/%d\n", len);
}


int main()
{
	//freopen("a.in", "r", stdin);
	int t;
	scanf("%d\n", &t);
	int g = 0;
	while (t--)
	{
		int n;
		scanf("%d\n", &n);

		node *root = new node();

		for (int i = 0; i < n; i++)
		{
			int a, b, c, d, len;
			scanf("%d.%d.%d.%d/%d\n", &a, &b, &c, &d, &len);

			uint x = ((uint)a) << 24;
			x |= ((uint)b) << 16;
			x |= ((uint)c) << 8;
			x |= d;


			node *v = root;

			for (int j = 0; j < len; j++)
			{
				int c = (x & (((uint)1) << (31 - j))) != 0;

				if (v->nxt[c] == NULL)
					v->nxt[c] = new node();
				v = v->nxt[c];
			}

			v->bad = 1;
		}

		ans.clear();
		dfs(root, 0, 0);
		g++;
		cout << "Case #" << g << ":" << endl;
		printf("%d\n", ans.size());

		for (auto x : ans)
			out(x.fst, x.snd);
	}

	return 0;
}