#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;



vector<vector<int> > rv,vv;
int nn;
int n,m;
bool win[20010];
bool used[20010];
void bfs(){
	queue<int> q;
	for(int i = 0;i < nn;i++){
		used[i] = false;
		if(win[i]){
			used[i] = true;
			q.push(i);
		}
	}
	while(!q.empty()){
		int v = q.front();
		q.pop();
		bool good = false;
		if(v>=n*n){
			for(int i = 0;i < L(vv[v]);i++){
				int to = vv[v][i];
				if(win[to]){
					good = true;
				}
			}
			if(good)
				win[v] = true;
			for(int i = 0;i < L(rv[v]);i++){
				int to = rv[v][i];
				if(!used[to]){
					used[to] = true;
					q.push(to);
				}
			}
		}else{
			for(int i = 0;i < L(vv[v]);i++){
				int to = vv[v][i];
				if(!win[to]){
					good = true;
				}
			}
			if(!good)
				win[v] = true;
			for(int i = 0;i < L(rv[v]);i++){
				int to = rv[v][i];
				if(!used[to]){
					used[to] = true;
					q.push(to);
				}
			}
		}

	}
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T;
	cin >> T;
	int test = 0;
	while(test++<T){
		cin >> n >> m;
		int x,y;
		vv.clear();
		rv.clear();
//		vv1.resize(n);
		vv.resize(n*n*2);
		nn = n*n*2;
		rv.resize(nn);
		for(int i = 0;i < nn;i++)
			win[i] = false;
		for(int i = 0;i < m;i++){
			int a,b;
			scanf("%d%d",&a,&b);
			a--;b--;
//			vv1[a].pb(b);
			for(int j = 0;j < n;j++){
				int fr = a*n+j;
				int to = b*n+j+n*n;
				vv[fr].pb(to);
				rv[to].pb(fr);
				fr = j*n+a+n*n;
				to = j*n+b;
				vv[fr].pb(to);
				rv[to].pb(fr);
			}
		}
		for(int i = 0;i < n;i++){
			win[i*n+i] = true;
			win[i*n+i+n*n] = true;
		}
		for(int i = 0;i < n;i++){
			for(int j = 0;j < n;j++){
				int v = i*n+j;
				if(L(vv[v])==0){
					win[v] = true;
				}
			}
		}
		int s1,s2;
		bfs();
		cin >> s1 >> s2;
		int v = s1*n+s2;
		printf("Case #%d: ",test);
		if(!win[v]){
			printf("Yes\n");
		}
		else
			printf("No\n");
	}


	return 0;
}
