#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const double PI = 3.1415926535897932384626433832795;

vector<pll> getv(ll fr, ll to) {
	vector<pll> ans;
	int ps = 31;
	while (ps >= 0 && ((fr>>ps)&1)==((to>>ps)&1)) --ps;
	ps++;
	ll ff = (fr>>ps)<<ps;
	ll tt = ff+(1LL<<ps)-1;
	if (fr == ff && to == tt) {
		ans.pb(mp(fr,to));
		return ans;
	}
	ll msk = (((1LL<<32)-1)>>ps)<<ps;
	ff = fr;
	tt = (fr&msk)+(1LL<<(ps-1))-1;
	vector<pll> tmp = getv(ff,tt);
	ans.insert(ans.end(), ALL(tmp));
	tt = to;
	ff = (to&msk)|(1LL<<(ps-1));
	tmp = getv(ff, tt);
	ans.insert(ans.end(), ALL(tmp));
	return ans;
}

void solve() {
	int n; scanf("%d", &n);
	vector<pll> v;
	forn(i, n) {
		int b1, b2, b3, b4, msk; scanf("%d.%d.%d.%d/%d", &b1, &b2, &b3, &b4, &msk);
		ll ip = ((ll)b1<<24)|((ll)b2<<16)|((ll)b3<<8)|(b4);
		ll mm = ((1LL<<msk)-1)<<(32-msk);
		ll fr = ip&mm;
		ll to = fr + (1LL<<(32-msk))-1;
		v.pb(mp(fr,to));
	}
	v.pb(mp(-1,-1));
	v.pb(mp((1LL<<32), (1LL<<32)));
	sort(ALL(v));
	vector<pll> ans;
	forn(i, sz(v)-1) {
		pll cur = mp(v[i].Y+1,v[i+1].X-1);
		if (cur.X <= cur.Y) ans.pb(cur);
	}
	vector<pll> res;
	forn(i, sz(ans)) {
		vector<pll> tmp = getv(ans[i].X, ans[i].Y);
		res.insert(res.end(), ALL(tmp));
	}
	printf("%d\n", sz(res));
	forn(i, sz(res)) {
		ll cur = res[i].X;
		ll fr = res[i].X;
		ll to = res[i].Y;
		int b4 = cur&((1<<8)-1);
		int b3 = (cur>>8)&((1<<8)-1);
		int b2 = (cur>>16)&((1<<8)-1);
		int b1 = (cur>>24)&((1<<8)-1);
		printf("%d.%d.%d.%d", b1, b2, b3, b4);
		int ps = 31;
		while (ps >= 0 && ((fr>>ps)&1)==((to>>ps)&1)) --ps;
		int len = 32-ps-1;
		//if (len != 32) 
		printf("/%d", len);
		printf("\n");
	}
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); for (int t = 1; t <= T; ++t) {
		printf("Case #%d:\n", t);
		solve();
	}
	return 0;
}
