#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

vector < int > g[maxn];
int n, m;
int used[101][101][400];


int dfs(int x, int y, int t){
	if(x == y) return 0;
	if( t == 398 ) return 1;
	int &res = used[x][y][t];
	if(res != -1 ) return res;
	if( t % 2 == 0 ){
		res = 0;
		for(int i = 0; i < g[x].size(); i++){
			int to = g[x][i];
			res |= dfs(to, y, t+1);
		}
	}
	else {
		res = 1;
		for(int i = 0; i < g[y].size(); i++){
			int to = g[y][i];
			res &= dfs(x, to, t+1);
		}
	}
	return res;
}


int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);
	for(int j = 1; j <= t; j++){
	memset(used, -1, sizeof used);
	cin >> n >> m;
	for(int i = 0; i<m; i++){
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		g[x].pb(y);
	}
	int x, y;
	cin >> x >> y;
	x--;
	y--;

	int ok = dfs(x, y, 0);
	if(ok) cout << "Case #" << j << ": Yes\n";
	else cout << "Case #" << j <<": No\n";
	for(int i = 0; i < n; i++) g[i].clear();
	}

	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
