#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

const int mod = (int)1e9 + 7;

const int maxn = (int)1e6 + 10;

int o[maxn];
int ans[maxn];

int binpow(int a, int b) {
	int res = 1;
	while(b) {
		if (b & 1) res = res * 1LL * a % mod;
		a = a * 1LL * a % mod;
		b >>= 1;
	}
	return res;
}

int C(int n, int m) {
	if (m > n) return 0;
	int res = 1;
	for (int i = n - m + 1; i <= n; i++) {
		res = res * 1LL * i % mod;
	}
   	res = res * 1LL * o[m] % mod;
    return res;
}

void solve() {
	int n,m,k; cin >> n >> m >> k;
	if (n == 1) {
		cout << m << endl;
		return;
	}
	if (k == 1) {
		cout << 0 << endl;
		return;
	}
	ans[2] = 2;
	int sum = ans[2];
	for (int i = 3; i <= k; i++) {
		ans[i] = i * 1LL * binpow(i - 1,n - 1) % mod;
		ans[i] -= (i - 1) * 1LL * binpow(i - 2,n - 1) % mod;
		if (ans[i] < 0) ans[i] += mod;
		ans[i] -= sum * 1LL * (i - 1) % mod;
		if (ans[i] < 0) ans[i] += mod;
		sum += ans[i];
		if (sum >= mod) sum -= mod;
	}
	cout << ans[k] * 1LL * C(m,k) % mod << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int f = 1;
	o[0] = 1;
	for (int i = 1; i < maxn; i++) {
		f = f * 1LL * i % mod;
		o[i] = binpow(f,mod - 2);
	}

	int T; cin >> T;

	for (int t = 1; t <= T; t++) {
		cout << "Case #" << t << ": ";
		solve();
	}

	return 0;
}