#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

ll A, B;

inline ll get(ll a, ll b)
{
	if (a == 0 && b == 0) return 1;
	if (a == 0) return 2;
	if (b == 0) return 2;
	ll ans = 0;
	while (b) {
		ll k = a / b;
		ans += k;
		a -= k * b;
		swap(a,b);
	}
	ans += 1;
	return ans;
}

inline void solve()
{
	cin >> A >> B;
	cout << get(A, B) << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int tt;
	scanf("%d", &tt);
	for (int t = 0; t < tt; ++t)
	{
		printf("Case #%d: ", t + 1);
		solve();
	}

	return 0;
}
