#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "g"

#define M 800800

struct Node
{
	map<char, Node*> go;
	int len;
	Node *link;
	pair<int, int> c;
	
	Node(): len(0), link(nullptr), c(0, 0) {}
} tree[M];

pair<int, int> operator+(const pair<int, int> &x, const pair<int, int> &y)
{
	return pair<int,int>(x.fi + y.fi, x.se + y.se);
}

Node *last;
int tree_size;
string s;

Node *getNext()
{
	tree[tree_size] = Node();
	return tree + tree_size++;
}

void ini()
{
	tree_size = 0;
	Node *p = getNext();
	Node *q = getNext();
	
	p->len = -1;
	
	q->len = 0;
	q->link = p;
	
	last = q;
	
}

void add(int pos)
{
	char ch = s[pos];
	Node *cur = last;
	while (s[pos - cur->len - 1] != s[pos])
		cur = cur->link;
	
	if (cur->go[ch] != nullptr)
	{
		last = cur->go[ch];
		//cerr << "LIL\n";
		return;
	}
	
	cur->go[ch] = getNext();
	cur->go[ch]->len = cur->len + 2;
	
	if (cur == tree + 1)
	{
		cur->go[ch]->link = tree->go[ch];
	}
	else if (cur == tree)
	{
		cur->go[ch]->link = tree + 1;
	}
	else
	{
		Node *p = cur->link;
		while (s[pos - p->len - 1] != s[pos])
			p = p->link;
		cur->go[ch]->link = p->go[ch];
	}
	last = cur->go[ch];
}

void kill()
{
	string a, b;
	cin >> a >> b;
	s = a + "#$" + b;
	ini();
	for (int i = 0; i < (int) s.length(); ++i)
	{
		add(i);
		if (i < a.length())
			last->c.fi++;
		if ((int) a.length() + 2 <= i)
			last->c.se++;
	}
	
	for (int i = tree_size - 1; i > 0; --i)
		tree[i].link->c = tree[i].link->c + tree[i].c;
	
	long long ans = 0;
	for (int i = 0; i < tree_size; ++i)
		if (tree[i].len > 0)
			ans += 1ll * tree[i].c.fi * tree[i].c.se;
	
	cout << ans << "\n";
	
//	for (int i = 0; i < tree_size; ++i)
//	{
//		cerr << i << ":\n";
//		cerr << "len: " << tree[i].len << "\n";
//		if (tree[i].link != nullptr)
//			cerr << "link: " << ((int)(tree[i].link - tree)) << "\n";
//		else
//			cerr << "link: nullptr\n";
//		for (auto it : tree[i].go)
//			cerr << it.first << " -> " << ((int) (it.second - tree)) << "\n";
//		cerr << "--\n";
//	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int tn;
	cin >> tn;
	for (int i = 1; i <= tn; ++i)
	{
		cout << "Case #" << i << ": ";
		kill();
	}
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
