#include <iostream>
#include <vector>
#include <set>
#include <cstdio>

using namespace std;

const int maxn = 105;

int n;
vector<int> a;

int calcInv() {
    int ans = 0;
    for (int i = 0; i < a.size(); ++i)
        for (int j = i + 1; j < a.size(); ++j)
            if (a[i] > a[j]) ++ans;
    return ans;
}

int main()
{
    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        a.clear();
        cin >> n;
        a.resize(n);
        for (int i = 0; i < n; ++i)
            cin >> a[i];

        double best_ans = calcInv() * 1.0 / n;

        for (int i = 0; i < n; ++i) {
            int bj = -1, binv = 1e9;
            for (int j = 0; j < a.size(); ++j) {
                int tmp = 0;
                for (int k = 0; k < j; ++k)
                    if (a[k] > a[j]) ++tmp;
                for (int k = j + 1; k < a.size(); ++k)
                    if (a[k] < a[j]) ++tmp;
                if (tmp < binv || bj == -1) binv = tmp, bj = j;
            }
            a.erase(a.begin() + bj);
            int inv = calcInv();
            best_ans = max(best_ans, inv * 1.0 / a.size());
        }
        printf("Case #%d: %.8f", test, best_ans);
    }
    return 0;
}
