#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <ctime>
#include <cassert>

using namespace std;

typedef long long ll;

ll ans3 = 0;

void gcd(ll a, ll b) {
//    cerr << a << " " << b << endl;
    if (a == 0) return;
    if (a > b) swap(a, b);
    ans3 += b / a;
//    cerr << b / a << endl;
    gcd(b % a, a);
}

ll solve(ll a, ll b) {
//    cerr << "gcd = " << d << endl;
    if (a == 0 && b == 0)
        return 1;
    else if (a == 0 || b == 0 || a == b)
        return 2;
    else
    {
        ll xmin = min(a, b);
        ll xmax = max(a, b);
        ll diff = abs (a - b);
        if (xmin >= diff)
        {
            ll g = __gcd(a, b);
            assert (diff > 0);
            return diff/g + (xmin - 1)/diff + 2;
        }
        else
            return solve(xmax, diff);
    }
}

ll stupidSolve(ll a, ll b) {
    set<ll> z;
    vector<ll> seq;
    seq.push_back(a);
    seq.push_back(b);
    z.insert(a);
    z.insert(b);
    while (true) {
        if (a == 0 || b == 0)
            break;
        ll tmp = abs(b - a);
        a = b;
        b = tmp;
        seq.push_back(tmp);
        z.insert(a);
        z.insert(b);
//        cerr << a << " " << b << endl;
    }

    cerr << "Seq: ";
    for (int i = 0; i < seq.size(); ++i)
        cerr << seq[i] << " ";
    cerr << endl;
    cerr << "Numbers: " << z.size() << endl;

    return z.size();
}

int main()
{
    int tests;
    ll a, b, ans;

    srand(time(0));

    cin >> tests;

//    while (true)
    for (int i = 0; i < tests; i++)
    {
        ans3 = 0;
       cin >> a >> b;
//        a = rand() % 100 + 1;
//        b = rand() % 100 + 1;

        if (a == 0 && b == 0) ans3 = 1;
        else if (a == 0 || b == 0) ans3 = 2;
        else gcd(a, b), ++ans3;

//        cout << a << " " << b << endl;

//        ll ans1 = solve(a, b);
//        ll ans2 = stupidSolve(a, b);
//        assert (ans2 == stupidSolve(max(a, b), abs(a - b)));
//        gcd(a, b);
//        cerr << abs(a - b) / __gcd(a, b) << " " << ans3 << endl;

/*        if (ans3 + 1 != ans2) {
            cout << ans1 << " != " << ans3 + 1 << endl;
            return 1;
        }*/
        cout << "Case #" << i + 1 << ": " << ans3 << endl;

//        cout << "Case #" << i + 1 << ": " << ans << endl;
    }

    return 0;
}
