#include <iostream>
#include <vector>
#include <cstdio>
#include <map>

using namespace std;

inline void printsolve(unsigned int a, unsigned int b){
	cout << (a >>24) << '.' << (a << 8 >> 24) << '.' << (a  << 16 >> 24) << '.' << (a << 24 >> 24) << '/' << b << endl;
}

inline unsigned int reverseb(unsigned int a, int i){
	return a ^ (1 << i);
}

inline unsigned int nulling(unsigned int a, int i){
	return a & reverseb((0 - 1), i);
}

struct otv{
	int a, b;
};

void solve(int j)
{
	unsigned int n;
	cin >> n;
	vector<otv>ot;
	vector<vector<unsigned int> > s(33);
	for(int i = 0; i< n; i++){
		unsigned int a, b, c, d, e;
		scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &e);
		a = a<<24 + b<<16 + c<<8 + d;
		a = a>>(32 -e) <<(32-e);
		s[e].push_back(a);
	}
	cout << "Case #" << j << ": " << endl;
	
	for(unsigned int i = 32; i > 0; i--){
		for(unsigned int j = 0; j < s[i].size(); j++){
			otv o;
			o.a = reverseb(s[i][j], 32 - i);
			o.b = i;
			ot.push_back(o);
			s[i-1].push_back(nulling(s[i][j], 32 - i));
		}
	}

	if(ot.size() == 0){
		if(n == 0){
		otv o;
		o.a = 0;
		o.b = 0;
		ot.push_back(o);
		}
	}
	cout << ot.size() << endl;
	for(int i = 0; i < ot.size(); i++)
		printsolve(ot[i].a, ot[i].b);

}

int main()
{
	int t;
	//cout << nulling(1536, 10);
	cin >> t;
	for(int i = 0; i < t; i++)
		solve(i+1);
	//cout << pow2(3, 3);
	cin >> t;
	return 0;
}