#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <cstdio>

using namespace std;

const long long MOD = 1000000007;

long long pow2(long long n, long long k)
{
	long long t = 1;
	while(k){
		if(k & 1){
			t *= n;
			t %= MOD;
		}
		n*= n;
		n %= MOD;
		k >>= 1;
	}
	return t;
}

void solve(int j)
{
	long long n, k, t, res = 0;
	cin >> n >> k;
	if(n < k){
		t = n;
		n = k;
		k = k - t;
	}

	while(k){
		res += n/k;
		t = n;
		n = k;
		k = t%k;
	}
	
	cout << "Case #" << j << ": " << res+1 << endl;
}

int main()
{
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve(i+1);
	//cout << pow2(3, 3);
	//cin >> t;
	return 0;
}