#include<iostream>
#include<stdio.h>
#include<map>
using namespace std;

typedef long long lint;

const int BASE = 1000*1000*1000+7;
lint bpow(lint a,lint b)
{
	if(b==0) return 1;
	if(b==1) return a%BASE;
	lint z = bpow(a,b/2);
	z=(z*z)%BASE;
	if(b%2==1) z=(z*a)%BASE;
	return z;
}

lint f(lint n,lint k)
{
	return (k*bpow(k-1,n-1))%BASE;
}

lint gcd(lint a,lint b,lint &x,lint &y)
{
	if(a==0)
	{
		x=0; y=1;
		return b;
	}
	lint x1,y1;
	lint d = gcd(b%a,a,x1,y1);
	x=y1-(b/a)*x1;
	y=x1;
	return d;
}



lint C(lint n,lint k)
{
	lint result=1,i,x,y;
	for(i=n;i>=n-k+1;i--) result=(result*i)%BASE;
	for(i=2;i<=k;i++)
	{
		gcd(i,BASE,x,y);
		x%=BASE;
		x+=BASE;
		x%=BASE;
		result=(result*x)%BASE;
	}
	return result;
}



void solve(int t)
{
	int N,M,K,temp;
	lint answer;

	scanf("%d%d%d",&N,&M,&K);
	if(K==1)
	{
		if(N==1) answer=C(M,K);
		else answer=0;
	}
	else
	{
		temp=(K*f(N,K-1))%BASE;
		answer = (f(N,K)-temp)%BASE;
		answer = (answer+BASE)%BASE;
		answer = (C(M,K)*answer)%BASE;
	}
	int ans=int(answer);
	printf("Case #%d: %d\n",t,ans);
}



int main()
{
	int T,i;
	scanf("%d",&T);
	for(i=1;i<=T;i++) solve(i);
	return 0;
}