#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <set>

using namespace std;

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;
    
    cin >> tests;

    for (int test = 0; test < tests; test++) {
        long long a, b;
        cin >> a >> b;

        cout << "Case #" << test + 1 << ": ";

        set< long long > s;

        s.insert(a);
        s.insert(b);

        for (int i = 0; i < 200; i++) {
            long long c = abs(a - b);

            s.insert(c);

            a = b;
            b = c;
        }

        cout << s.size() << endl;
    }

    return 0;
}
