#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <set>

using namespace std;

pair< long long, long long > gcd(long long a, long long b) {
    if (b == 0) {
        return make_pair(a, 0);
    }

    pair< long long, long long > cur = gcd(b, a % b);
    cur.second += a / b;

    return cur;
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;
    
    cin >> tests;

    for (int test = 0; test < tests; test++) {
        long long a, b;
        cin >> a >> b;

        cout << "Case #" << test + 1 << ": ";

        if (a == b) {
            cout << 1 + (a != 0) << endl;
            continue;
        } else if (a == 0 || b == 0) {
            cout << 2 << endl;
            continue;
        }

        pair< long long, long long > g = gcd(a, b);

        cout << g.second + 1 << endl;
    }

    return 0;
}
