#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

struct node {
    node * link;
    node * next[26];
    int len;
    int cnt[2];
    node() {
        link = 0;
        memset(next, 0, sizeof(next));
        memset(cnt, 0, sizeof(cnt));
    }
};

node * cur;

vector <node *> nodes;

node * add(node * cur, int pos, const string & s, int k) {
    while (s[pos - cur->len - 1] != s[pos]) {
        cur = cur->link;
        if (cur == cur->link) {
            break;
        }
    }
    node * u = cur->link;
    node * to = cur->next[s[pos] - 'a'];
    node * link = (u != cur) ? add(u, pos, s, -1) : cur;

    if (!to) {
        to = cur->next[s[pos] - 'a'] = new node();
        to->len = cur->len + 2;
        to->link = link;
        nodes.push_back(to);
    }
    if (k >= 0) to->cnt[k]++;
    return to;
}

node * root;

void init() {
    node * a = new node();
    a->len = -1;
    node * b = new node();
    b->len = 0;
    a->link = b->link = a;
    nodes.push_back(a);
    nodes.push_back(b);
    root = a;
}

void solve(){
    in(t);
    int c = 0;
    while (t--) {
        cout << "Case #" << ++c << ": ";
        init();
        nodes.clear();
        string a, b;
        cin >> a >> b;
        cur = root;
        for (int i = 0; i < (int)a.length(); ++i) {
            cur = add(cur, i, a, 0);
        }
        cur = root;
        for (int i = 0; i < (int)b.length(); ++i) {
            cur = add(cur, i, b, 1);
        }
        int N = max(a.length(), b.length()) + 1;
        vector <node *> byLen[N + 1];
        for (node * u : nodes) {
            byLen[u->len + 1].push_back(u);
        }
        long long ans = 0;
        for (int i = N; i >= 0; --i) {
            for (node * nd : byLen[i]) {
                if (nd->len > 0) {
                    ans += (long long)nd->cnt[0] * nd->cnt[1];
                }
                nd->link->cnt[0] += nd->cnt[0];
                nd->link->cnt[1] += nd->cnt[1];
            }
        }
        cout << ans << "\n";
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
