#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>
#include <queue>
#include <stack>
using namespace std;

typedef long long ll;

const ll M = 1000000007;
const int N = 1000002;
ll rv[N];
inline ll binpow(ll num, ll pow){
	if (num == 0) return 0;
	ll ans = 1;
	num %= M;
	while (pow){
		if (pow & 1){
			ans *= num;
			ans %= M;
		}
		pow >>= 1;
		num *= num;
		num %= M;
	}
	return ans;
}

inline ll Cnk(ll n, ll k){
	if (k > n) return 0;
	ll ans = 1;
	for (ll i = 0; i < k; ++i){
		ans *= (n - i) % M;
		ans %= M;
		ans *= rv[i + 1];
		ans %= M;
	}
	return ans;
}

int main(){
	ios_base::sync_with_stdio(false);
	int ttt; cin >> ttt;
	for (int i = 0; i < N; ++i)
		rv[i] = binpow(i, M - 2);
	for (int t = 0; t < ttt; ++t){
		ll n, m, k;
		cin >> n >> m >> k;
		ll a = k * binpow(k - 1, n - 1) % M;
		ll b = (k - 1) * binpow(k - 2, n - 1) % M;
		ll ans = (a - b + M) % M * Cnk(m, k) % M;
		cout << "Case #" << t + 1 << ": " << ans << endl;
	}
	return 0;
}