#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <set>
#include <queue>
#include <stack>
#include <cstdio>
using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, uint> msk;

inline msk scanmsk(){
	int a, b, c, d, f;
	scanf("%d.%d.%d.%d/%d", &a, &b, &c, &d, &f);
	return make_pair(f, ((uint)a << 24) | (b << 16) | (c << 8) | d);
}
inline void prntmsk(const msk& m){
	printf("%d.%d.%d.%d/%d\n", 
		(m.second >> 24),
		((m.second >> 16) & ((1 << 8) - 1)),
		((m.second >> 8) & ((1 << 8) - 1)),
		((m.second) & ((1 << 8) - 1)),
		m.first);
}

inline bool bad(const set<msk>& ss, const msk& a){
	uint b = a.second;
	for (int i = 0; i < a.first; ++i){
		uint cb = (((uint)1) << (32 - a.first + i));
		b &= ~cb;
		if (ss.find(make_pair(a.first - 1 - i, b)) != ss.end()) return true;
	}
	return false;
}

inline void make_good(set<msk>& ss){
	if (ss.size() == 0) return;
	for (set<msk>::iterator it = ss.end(); it != ss.begin(); ){
		--it;
		if (bad(ss, *it)){
			it = ss.erase(it);
		}
	}
}

inline msk makesmallinv(const msk& m){
	msk ans = m;
	ans.second ^= (((uint)1) << 32 - m.first);
	return ans;
}

int main(){
	//ios_base::sync_with_stdio(false);
	int ttt; cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		set<msk> ss;
		printf("Case #%d:\n", i + 1);
		int n; scanf("%d", &n);
		if (n == 0) {
			printf("1\n");
			printf("0.0.0.0/0\n");
			continue;
		}
		vector<msk> ans;
		bool ok = true;
		for (int i = 0; i < n; ++i){
			msk m = scanmsk();
			ok = ok && m.first != 0;
			ss.insert(m);
		}
		if (!ok){
			printf("0\n");
			continue;
		}
		make_good(ss);
		while(ss.size() > 0){
			set<msk>::reverse_iterator it = ss.rbegin();
			msk inv = makesmallinv(*it);
			if (ss.find(inv) != ss.end()){
				ss.erase(*it);
				ss.erase(inv);
			} else {
				ans.push_back(inv);
				ss.erase(*it);
			}
			if (inv.first > 1){
				inv.second &= ~(((uint)1) << (32 - inv.first));
				--inv.first;
				ss.insert(inv);
			}
		}
		printf("%d\n", (int)ans.size());
		for (int i = 0; i < ans.size(); ++i)
			prntmsk(ans[i]);
	}
	return 0;
}