#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int M = (int) 1e9 + 7;
const int K = (int) 1e6 + 10;
int inv[K + 1], t, n, m, k;

int mult(int a, int b) {
	return (a * (int64) b) % M;
}

int pow(int a, int b) {
	if (b == 0) return 1;
	if (b & 1) return mult(pow(a, b - 1), a);
	int tmp = pow(a, b / 2);
	return mult(tmp, tmp);
}

int inverse(int a) {
	return pow(a, M - 2);
}


int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int i = 1; i <= K; ++i)
		inv[i] = inverse(i); 
	for (int it = 0; it < t; ++it) {
		scanf("%d%d%d", &n, &m, &k);
		int64 res = 0;
		for (int i = 0, sign = 1, cnk = 1; i < k; ++i, sign *= -1) {
			res += mult(mult(M + sign * cnk, k - i), pow(k - i - 1, n - 1)); 
			cnk = mult(mult(cnk, k - i), inv[i + 1]);
		}
		res %= M;
		int cnk = 1;
		for (int i = 0; i < k; ++i)
			cnk = mult(mult(cnk, m - i), inv[i + 1]);
		printf("Case #%d: %d\n", it + 1, mult(res, cnk));
	}
	return 0;
}