#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 500 * 1000;

int way[2][size][26];
int len[2][size];
int tc, n;
int tsize[2];
int suflink[2][size];
int cnt[2][size];
long long ans = 0;

char buf[size];

void dfs(int v1, int v2) {
	if (len[0][v1] > 0)
		ans += cnt[0][v1] * 1ll * cnt[1][v2];
	for (int i = 0; i < 26; i++)
		if (way[0][v1][i] != 0 && way[1][v2][i] != 0)
			dfs(way[0][v1][i], way[1][v2][i]);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		for (int i = 0; i < 2; i++) {
			scanf("%s", buf);
			int n = strlen(buf);
			tsize[i] = 2;

			suflink[i][0] = -1;
			suflink[i][1] = 0;
			len[i][0] = -1;
			len[i][1] = 0;
			cnt[i][0] = 0;
			cnt[i][1] = 0;
			for (int j = 0; j < 2; j++)
				for (int k = 0; k < 26; k++)
					way[i][j][k] = 0;

			int cur = 0;
			for (int j = 0; j < n; j++) {
				while (buf[j] != buf[j - 1 - len[i][cur]])
					cur = suflink[i][cur];
				if (way[i][cur][buf[j] - 'a'] != 0)
					cur = way[i][cur][buf[j] - 'a'];
				else {
					int nv = tsize[i]++;
					cnt[i][nv] = 0;
					for (int k = 0; k < 26; k++)
						way[i][nv][k] = 0;
					len[i][nv] = len[i][cur] + 2;
					way[i][cur][buf[j] - 'a'] = nv;
					int h = suflink[i][cur];
					while (h != -1 && (way[i][h][buf[j] - 'a'] == 0 || buf[j] != buf[j - 1 - len[i][h]]))
						h = suflink[i][h];
					if (h == -1)
						suflink[i][nv] = 1;
					else
						suflink[i][nv] = way[i][h][buf[j] - 'a'];
				
					cur = nv;
				}

				cnt[i][cur]++;
			}

			for (int j = tsize[i] - 1; j > 0; j--)
				cnt[i][suflink[i][j]] += cnt[i][j];
		}

		ans = 0;
		dfs(0, 0);
		dfs(1, 1);

		printf("Case #%d: %lld\n", tnum + 1, ans);
	}

	return 0;
}