#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = 111;
vector<int> adj[N];
vector< pair< pair<int, int>, int > > go[N][N][2];
int deg[N][N][2], color[N][N][2], u, v, t, n, m;

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; ++i)
			adj[i].clear();
		for (int i = 0; i < m; ++i) {
			scanf("%d%d", &u, &v), --u, --v;
			adj[u].pb(v);
		}
		queue< pair< pair<int, int>, int > > q;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				for (int t = 0; t < 2; ++t) {
					go[i][j][t].clear();
					color[i][j][t] = -1;
					deg[i][j][t] = 0;
				}
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				if (i != j) {
					for (int x = 0; x < sz(adj[i]); ++x) {
						go[adj[i][x]][j][1].pb(mp(mp(i, j), 0));
						deg[i][j][0]++;
					}
					for (int x = 0; x < sz(adj[j]); ++x) {
						go[i][adj[j][x]][0].pb(mp(mp(i, j), 1));
						deg[i][j][1]++;
					}
				} else {
					go[i][j][0].pb(mp(mp(i, j), 1));
					deg[i][j][1]++;
				}
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				for (int t = 0; t < 2; ++t)
					if (deg[i][j][t] == 0) {
						color[i][j][t] = 0;
						q.push(mp(mp(i, j), t));
					}
		while (!q.empty()) {
			int i = q.front().fs.fs, j = q.front().fs.sc, t = q.front().sc;
			q.pop();
			if (color[i][j][t] == 0) {
				for (int x = 0; x < sz(go[i][j][t]); ++x) {
					int ni = go[i][j][t][x].fs.fs, nj = go[i][j][t][x].fs.sc, nt = go[i][j][t][x].sc;
					if (color[ni][nj][nt] == -1) {
						color[ni][nj][nt] = 1;
						q.push(mp(mp(ni, nj), nt));
					}
				}
			} else {
				for (int x = 0; x < sz(go[i][j][t]); ++x) {
					int ni = go[i][j][t][x].fs.fs, nj = go[i][j][t][x].fs.sc, nt = go[i][j][t][x].sc;
					if ((color[ni][nj][nt] == -1) && (--deg[ni][nj][nt] == 0)) {
						color[ni][nj][nt] = 0;
						q.push(mp(mp(ni, nj), nt));
					}
				}
			}
		}
		scanf("%d%d", &u, &v), --u, --v;
		printf("Case #%d: %s\n", it + 1, (color[u][v][0] == 0) ? "No" : "Yes");
	}
	return 0;
}