#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

struct node {
	int term; 
	node * l;
	node * r; 

	node(): term(0), l(NULL), r(NULL) {}
}; 

vi aa;
node * bor; 

void clear(node * v) {
	if (!v) return; 
	clear(v->l); 
	clear(v->r); 
	delete v;
}

node * dfs(node * v, int i, int n) {
	node * cur = v; 
	if (!cur) cur = new node(); 
	if (n == 0) {
		cur->term = 1; 
		return cur; 
	}
	if (aa[i]) cur->r = dfs(cur->r, i + 1, n - 1); 
	else cur->l = dfs(cur->l, i + 1, n - 1); 
	return cur; 
}

vector<pair<vi, int> > ans; 

void out2(int p) {

}

void out(int p) {
	ans.pb(mp(aa, p)); 
}

void solve(node * v, int p = 0) {
	if (!v) out(p); 
	else {
		if (v->term) return; 
		aa[p] = 0; 
		solve(v->l, p + 1);
		aa[p] = 1; 
		solve(v->r, p + 1); 
		aa[p] = 0; 
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	
	int t; 
	scanf("%d ", &t);

	for (int tt = 0; tt < t; tt++) {
		printf("Case #%d:\n", tt + 1); 
		clear(bor);
		bor = NULL; 
		int n; 
		scanf("%d ", &n); 
		if (n == 0) {
			puts("1\n0.0.0.0/0"); 
			continue;
		}
		
		aa.resize(32);
		for (int k = 0; k < n; k++) {
			int a[4] = { 0 }; 
			int num;
			scanf("%d.%d.%d.%d/%d ", &a[0], &a[1], &a[2], &a[3], &num); 
			aa; 
			int cnt = 0; 
			for (int i = 0; i < 4; i++) {
				for (int j = 7; j >= 0; j--) {
					aa[cnt++] = (a[i] >> j) & 1; 
				}
			}
			bor = dfs(bor, 0, num); 
		}
		
		ans.clear();
		aa.clear(); 
		aa.resize(32, 0); 
		solve(bor); 

		printf("%d\n", ans.size()); 
		for (int i = 0; i < ans.size(); i++) {
			int x = 0; 
			vi aa = ans[i].first; 
			int p = ans[i].second; 
			for (int i = 0; i < 4; i++) {
				x = 0; 
				int cnt = 7; 
				for (int j = i * 8; j < i * 8 + 8; j++, cnt--) {
					x |= (aa[j] << cnt); 
				}
				printf("%d", x);
				if (i != 3) printf("."); 
				else printf("/");
			}
			printf("%d\n", p);
		}
	}

	return 0;
}