#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

ll f(ll xi, ll yi)
{
	//ll xi = x, yi = y; 
	ll x = xi;
	ll y = yi;

	map < pair<ll, ll>, int > used;
	set <ll> all;
	used[mp(x, y)]= 1; 
	//cout << x << " " << y << " "; 
	all.insert(x);
	all.insert(y);
	while(1) {
		ll t = y;
		if (x - y > 0) 
			y = x - y; 
		else 
			y = y - x;  
		x = t;
		all.insert(y);
		//if (used[mp(y, x)]) break; 
		if (used[mp(x, y)]) break; 
		used[mp(x, y)] = 1;
	} 
	return all.size();
}

ll ff(ll x, ll y)
{
	//if (x > y)
	//	swap(x, y);

	if (x == y)
		return 0;

	if (y > x)
	{
		ll k = y / x;
		if (k % 2)
			return k + 1 + f(x, (k + 1) * x - y);
		else
			return k + 1 + f(y - k * x, (k + 1) * x - y);
	}
}

ll f3(ll a, ll b)
{
	if (b == 0)
		return 0;
	return a / b + f3(b, a % b);
}



int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int T;
	scanf("%d", &T);
	for (int t = 0; t < T; ++t)
	{
		ll x, y;
		scanf("%lld %lld", &x, &y);
		ll ans = f3(x, y) + 1;
		printf("Case #%d: %lld\n", t + 1, ans);
	}

	


	return 0;
}