#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

int real(int a, int b)
{
	set<pair<int, int> > st;
	set<int> S;
	S.insert(a);
	S.insert(b);
	st.insert(make_pair(a, b));
	while (1)
	{
		int r = abs(a - b);
		if (st.find(make_pair(b, r)) != st.end())
			break;
		st.insert(make_pair(b, r));
		S.insert(r);
		a = b, b = r;
	}
	return S.size();
}

llong my(llong a, llong b)
{
	//scanf(LLD " " LLD, &a, &b);
	if (a < b)
		swap(a, b);
	if (a == 0)
		return 1;
	else if (b == 0)
		return 2;
		
	llong ans = 2;
	while (a % b != 0)
	{
		llong r = a % b;
		llong q = (a - r) / b;
		ans += q;
		a = b;
		b = r;
	}
	ans += a / b - 1;
	//printf(LLD "\n", ans);
	return ans;
}

int main() {
#ifdef LOCAL42
#define TASK "K"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
	{
		llong a, b;
		scanf(LLD " " LLD, &a, &b);
		llong ans1 = my(a, b);
		//llong ans2 = real(a, b);
		//assert(ans1 == ans2);
		printf("Case #%d: " LLD "\n", i + 1, ans1);
	}
	
	return 0;
}
