#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
#define MOD 10007
#define mp make_pair

long long g=0;
set<long long>ss;

long long gcd(long long a, long long b){
	if(!b)return a;
	return gcd(b,a%b);
}
//
//long long abs(long long a){
//	return a>0 ? a : -a;
//}

long long f(long long a, long long b){
	long long ans = 0;
	if(!ss.count(b)){
		ans++;
		ss.insert(b);
	}
	if(!b){
		return ans;
	}
	if(a>4*b){
		long long k = a / (2 * b) - 1;
		if(!ss.count(a-b)){
			ans++;
			ss.insert(a-b);
		}
		if(!ss.count(a-2*b)){
			ans++;
			ss.insert(a-2*b);
		}
		a -= 2 * b * k;
		return 2 * k + ans -2 + f(b, abs(a - b));
	}
	return ans+f(b, abs(a-b));
}

long long solve(long long a, long long b){
	ss.clear();
	if(!a || !b){
		if(a+b == 0){
			return 1;
		}
		else{
			return 2;
		}
	}
	g = gcd(a, b);
	ss.insert(a/g);
	return f(a/g, b/g) + 1;
}

void stress(){
	for(int i=2; i<20; ++i){
		for(int j=i; j<20; ++j){
			long long res = solve(i,j);
			set<int>ss;
			int a=i,b=j;
			int c;
			ss.insert(a);
			ss.insert(b);
			for(int k=0; k<1000; ++k){
				c=a;
				a=b;
				b=abs(b-c);
				ss.insert(a);
				ss.insert(b);
			}
			if(ss.size() != res){
				cout << i << " " << j << endl;
			}
		}
	}
}


void go(){
	int t;
	cin>>t;
	for(int TT=0;TT<t;++TT){
		long long a,b;
		cin>>a>>b;
		printf("Case #%d: ", TT+1);
		cout << solve(a,b) << endl;
	}
}


int main(){
	//freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	go();
	//stress();
	return 0;
}