#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n;
const int N = 105;
int a[N];

bool read() {
	if (!(cin >> n))
	return false;
	forn (i, n)
	{
	cin >> a[i];
	a[i]--;
	}
	/*n = 100;
	forn (i, n)
		a[i] = i;
	random_shuffle(a, a + n);*/
	return true;
}

int tc = 0;

int inv[N];

vector<int> g[N];

ld ans = INF;
ld cur = 0;

bool used[N];
int k, cnt;

//void rec()
//{
//	if (cur > ans)
//	{
//		cerr << cur << endl;
//		ans = cur;
//	}
//	if (cur < ans)
//		return;
//	int bt = INF;
//
//	forn (i, n)
//		if (!used[i]) bt = min(bt, inv[i]);
//
//	if (k > 1 && ld(cnt - bt) / (k - 1) >= cur - EPS)
//		forn (i, n)
//	{
//		if (used[i])
//			continue;
//		if (inv[i] == bt)
//		{
//			used[i] = true;
//			ld prev = cur;
//			cur = ld(cnt - bt) / (k - 1);
//			cnt -= bt;
//			k--;
//			forn (j, g[i].size())
//			{
//				int to = g[i][j];
//				inv[to]--;
//			}
//			rec();
//			used[i] = false;
//			cnt += bt, k++;
//			cur = prev;
//			forn (j, g[i].size())
//			{
//				int to = g[i][j];
//				inv[to]++;
//			}
//		}
//	}	
//}

void rec2()
{
	if (cur > ans)
	{
		ans = cur;
	}
	if (cur < ans || cur < EPS)
		return;

	forn (i, n)
	{
		if (used[i])
			continue;
		used[i] = true;
		ld prev = cur;
		cur = ld(cnt - inv[i]) / (k - 1);
		cnt -= inv[i];

		k--;
		forn (j, g[i].size())
		{
			int to = g[i][j];
			inv[to]--;
		}
		rec2();
		used[i] = false;
		cnt += inv[i], k++;
		cur = prev;
		forn (j, g[i].size())
		{
			int to = g[i][j];
			inv[to]++;
		}
	}	
}

void solve() {
	forn (i, N)
		g[i].clear(), inv[i] = 0;
	cout << "Case #" << ++tc << ":" << endl;
	memset(used, false, sizeof used);
	cur = cnt = 0;
	k = n;

	forn (i, n)
		forn (j, i)
		if (a[i] < a[j])
			cnt++, cur++, inv[j]++, inv[i]++, g[i].pb(j), g[j].pb(i);

	ans = 0;
	cur /= n;

	//rec();
	rec2();

	cout << fixed << setprecision(10) << ans << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	cin  >> t;

	while (read())
		solve();

	return 0;
}