#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

li a, b;

int naive(li a, li b) {
	set <int> s;
	while (min(a, b) != 0) {
		s.insert(a);
		s.insert(b);

		li c = abs(a - b);
		a = b;
		b = c;
	}

	s.insert(0);

	return s.size();
}

pair<li,li> gcd(li a, li b) {
	if (a < b)
		swap(a, b);
	if (b == 0)
		return mp(b, 1 + (a != b));
	pair <li,li> res = gcd(b, a % b);
	res.sc += a / b - (a % b == 0);
	return res;
}

bool read() {
	//a = rand() % 500 + 1;
	//b = rand() % 500 + 1;
	if (!(cin >> a >> b))
		return false;
	return true;
}

void solve() {
	cout << gcd(a, b).sc << endl;
	
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	forn(i, t) {
		cout << "Case #" << i + 1 << ": ";
		assert(read());
		solve();
	}

	return 0;
}