#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;

struct vect
{
    int x, y, t;
};

int n, m;

void rez ()
{
    scanf ("%d %d", &n, &m);
    queue <vect> q;
    int v[102][102] = {0};
    int grad[102] = {0};
    int cate[102][102] = {0}, sol[102][102][2] = {0};

    int i, j, k, x, y;

    for (i = 1; i <= m; i ++)
    {
        scanf ("%d %d", &x, &y);
        v[x][y] = 1;
    }

    for (i = 1; i <= n; i ++)
    {
        for (j = 1; j <= n; j ++)
            if (v[i][j])
                grad[i] ++;
        sol[i][i][0] = sol[i][i][1] = 1;
        q.push ((vect){i, i, 0});
        q.push ((vect){i, i, 1});
        for (j = 1; j <= n; j ++)
        {
            if (grad[i] == 0 && i != j)
            {
                sol[i][j][0] = 1;
                q.push ((vect){i, j, 0});
            }
            if (v[i][j])
                cate[i][j] = grad[i];
        }
    }

    while (!q.empty())
    {
        x = q.front().x;
        y = q.front().y;
        int t = q.front().t;
        q.pop();
        if (t)
        {
            for (i = 1; i <= n; i ++)
                if (v[i][y] && !sol[x][i][1])
                {
                    sol[x][i][1] = 1;
                    q.push((vect){x, i, 1});
                }
        }
        else
        {
            for (i = 1; i <= n; i ++)
                if (v[i][x] && !sol[i][y][0])
                    if (--cate[i][y] == 0)
                    {
                        sol[i][y][0] = 1;
                        q.push((vect){i, y, 0});
                    }
        }
    }

    scanf ("%d %d", &x, &y);
    printf ("%s\n", sol[x][y][0] ? "No" : "Yes");
}

int main ()
{
#ifdef local
    freopen ("h.in", "r", stdin);
    freopen ("h.out", "w", stdout);
#endif

    int t, tt;
    scanf ("%d", &t);
    for (tt = 1; tt <= t; tt ++)
    {
        printf ("Case #%d: ", tt);
        rez ();
    }
    return 0;
}
