#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 111;

struct State {
	int x, y, t;
	State() {}
	State(int x, int y, int t) : x(x), y(y), t(t) {}
};

int tt, n, m;
vector<State> gr[N][N][2];
vector<int> g[N];
int win[N][N][2], cnt[N][N][2];
                
int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &tt);
	int cur = 0;
	while (tt--) {
		cur++;
		printf("Case #%d: ", cur);
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; i++) g[i].clear();
		for (int i = 0; i < m; i++) {
			int x, y;
			scanf("%d%d", &x, &y);
			--x;
			--y;
			g[y].push_back(x);
		}
		int sx, sy;
		scanf("%d%d", &sx, &sy);
		--sx;
		--sy;
		vector<State> v;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int e = 0; e < 2; e++) {
					win[i][j][e] = -1;
					gr[i][j][e].clear();
					if (!e) {
						for (int o = 0; o < g[j].size(); o++) {
							gr[i][j][e].push_back(State(i, g[j][o], 1 - e));
						}
					} else {
						for (int o = 0; o < g[i].size(); o++) {
							gr[i][j][e].push_back(State(g[i][o], j, 1 - e));
						}
					}
				}
			}
		}
		memset(cnt, 0, sizeof(cnt));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int e = 0; e < 2; e++) {
					for (State o : gr[i][j][e]) cnt[o.x][o.y][o.t]++;
				}
			}
		}
		queue<State> q;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int e = 0; e < 2; e++) {
					if (i == j) {
						if (e == 0) win[i][j][e] = 0;
						else win[i][j][e] = 1;
						q.push(State(i, j, e));
					} 
				}
			}
		}
		while (!q.empty()) {
			State cc = q.front();
			q.pop();
			if (!win[cc.x][cc.y][cc.t]) {
				for (State dd : gr[cc.x][cc.y][cc.t]) {
					if (win[dd.x][dd.y][dd.t] == -1) {
						win[dd.x][dd.y][dd.t] = +1;
						q.push(dd);
					}
				}
			} else {
				for (State dd : gr[cc.x][cc.y][cc.t]) {
					--cnt[dd.x][dd.y][dd.t];
					if ((cnt[dd.x][dd.y][dd.t] == 0) && (win[dd.x][dd.y][dd.t] == -1)) {
						win[dd.x][dd.y][dd.t] = 0;
						q.push(dd);
					}
				}
			}
		}
		puts(win[sx][sy][0] == 0 ? "No" : "Yes");
	}
}