#if 1
#include <cstring>
#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;

const int maxn = 100;
int color [maxn][maxn][2];
int win[maxn][maxn][2];


int dfs(int a, int b, int bob, vvi &g)
{
	if(color[a][b][bob] == 1) return 1;
	if(color[a][b][bob] == 2) return win[a][b][bob];
	color[a][b][bob] = 1;

	int v = bob ? b : a;
	int res = 0;
	for (int i = 0; i < g[v].size(); ++i)
	{
		int to = g[v][i];
		if(bob)
		{
			if(to == a)  continue;
		}
		else
		{
			if(to == b) res = 2;
			continue; // ?
		}

		int loww;
		if(bob) loww = dfs(a, to, bob ^ 1, g);
		else loww = dfs(to, b, bob ^ 1, g);

		//[main]
		if(bob)
		{
			if(loww == 0) res = 2;
			if(loww == 1) res = 2;
		}
		else
		{
			if(loww == 0) res = 2;
		}
	}

	win[a][b][bob] = res;
	color[a][b][bob] = 2;
	return res;
}

using namespace std;
int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int T; scanf("%d", &T);
	for (int t = 1; t <= T; ++t)
	{
		memset(win, 0, sizeof(win));
		memset(color, 0, sizeof(color));
		int n, m; scanf("%d%d", &n, &m);
		vvi g(n);
		for (int i = 0; i < m; ++i)
		{
			int b, e; scanf("%d%d", &b, &e); --b; --e;
			g[b].push_back(e);
		}
		int x, y; scanf("%d%d", &x, &y); --x; --y;
		int res = dfs(y, x, 1, g);
		
		printf("Case #%d: %s\n", t, (res > 0) ? "Yes" : "No");
	}
	return 0;
}
#endif